RPL ( Ensure RPLCOMP and the syntax highlighter are in RPL mode )
( C:\Dokumente und Einstellungen\ag\Eigene Dateien\HP\Projects\GRW\main.s, part of the GRW.hpp project, created by <> on 14.12.2001 )

* lib 557 (22Dh) -- GraphWriter

*******************************************************************************

* Copyright (c) 2001-2015 by Albert Graef, Johannes Gutenberg University,
* Mainz, Germany.

* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 1, or (at your option)
* any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*******************************************************************************

* DESCRIPTION: This is a full-featured graph editor for the 49G/40G+/50G calculators.
* It allows you to create and edit a graph, represented in adjacency list form,
* in a graphical environment. The graph is drawn in PICT, using a user-defined
* coordinate system which can be configured using the SETUP option. There are
* two main entry points: GRW creates a new graph, while GRED edits the graph
* on level 1. Graphs may contain node and edge labels (as tagged values), and
* may have multiple edges and loops; a description of the syntax of the graph
* data structure can be found in graphops.s. A number of user-level operations
* for use in programming are also provided; see graphops.s for details.

*******************************************************************************

INCLUDE GRW.H

* additional stable(?) but unnamed entry points

ASSEMBLE
=^History               EQU     #008B002
=^SaveHARDBUFF          EQU     #0088002
=^RestoreHARDBUFF       EQU     #0089002
=^Choose3               EQU     #0072002
=^Choose3OK             EQU     #0076002
=^Choose3CANCL          EQU     #0077002
RPL

* keyboard definitions *******************************************************

* 49G key codes

DEFINE kpNoShift    ONE
DEFINE kpLeftShift  TWO
DEFINE kpRightShift THREE
DEFINE kcApps       SEVEN
DEFINE kcMode       EIGHT
DEFINE kcTool       NINE
DEFINE kcVar        ELEVEN
DEFINE kcSto        TWELVE
DEFINE kcNxt        THIRTEEN
DEFINE kcUpArrow    TEN
DEFINE kcLeftArrow  FOURTEEN
DEFINE kcDownArrow  FIFTEEN
DEFINE kcRightArrow SIXTEEN
DEFINE kcHist       SEVENTEEN
DEFINE kcCat        EIGHTEEN
DEFINE kcSymb       TWENTY
DEFINE kcBack       TWENTYONE
DEFINE kcChs        TWENTYEIGHT
DEFINE kcAlpha      THIRTYTWO
DEFINE kcTimes      THIRTYSIX
DEFINE kcLeftShift  THIRTYSEVEN
DEFINE kcMinus      FORTYONE
DEFINE kcRightShift FORTYTWO
DEFINE kcPlus       FORTYSIX
DEFINE kcOn         FORTYSEVEN
DEFINE kcEnter      FIFTYONE

* kludge to slow down key repeats on the 49G+/50g

DEFINE slowdown	SLOW SLOW SLOW

* local environment definitions **********************************************

* cursor position (x, y) and display configuration (xmax, ymax = screen
* dimension, xwin, ywin = current window offset), all in screen coords

DEFINE x        1GETLAM
DEFINE y        2GETLAM
DEFINE xmax     3GETLAM
DEFINE ymax     4GETLAM
DEFINE xwin     5GETLAM
DEFINE ywin     6GETLAM

DEFINE !x       1PUTLAM
DEFINE !y       2PUTLAM
DEFINE !xmax    3PUTLAM
DEFINE !ymax    4PUTLAM
DEFINE !xwin    5PUTLAM
DEFINE !ywin    6PUTLAM

* window setup (wxmin, wxmax, wymin, wymax = display range in user coords;
* wxr, wyr = display resolution in units/pixel; wz = zoom factor), including
* display modes (wnum?, wnlbl?, welbl? = show node numbers/labels, edge labels)

DEFINE wxmin    7GETLAM
DEFINE wxmax    8GETLAM
DEFINE wymin    9GETLAM
DEFINE wymax    10GETLAM
DEFINE wxr      11GETLAM
DEFINE wyr      12GETLAM
DEFINE wz       13GETLAM
DEFINE wnum?    14GETLAM
DEFINE wnlbl?   15GETLAM
DEFINE welbl?   16GETLAM

DEFINE !wxmin   7PUTLAM
DEFINE !wxmax   8PUTLAM
DEFINE !wymin   9PUTLAM
DEFINE !wymax   10PUTLAM
DEFINE !wxr     11PUTLAM
DEFINE !wyr     12PUTLAM
DEFINE !wz      13PUTLAM
DEFINE !wnum?   14PUTLAM
DEFINE !wnlbl?  15PUTLAM
DEFINE !welbl?  16PUTLAM

* mode flags (mode = edit mode indicator; coord? = coordinate display mode;
* edited? = flag indicating that graph has been edited; exit? = flag to
* terminate POL)

DEFINE mode     17GETLAM
DEFINE coord?   18GETLAM
DEFINE path?    19GETLAM
DEFINE edited?  20GETLAM
DEFINE exit?    21GETLAM

DEFINE !mode    17PUTLAM
DEFINE !coord?  18PUTLAM
DEFINE !path?   19PUTLAM
DEFINE !edited? 20PUTLAM
DEFINE !exit?   21PUTLAM

* mark/callback and selection

DEFINE mark     22 GETLAM
DEFINE callb    23 GETLAM
DEFINE select   24 GETLAM

DEFINE !mark    22 PUTLAM
DEFINE !callb   23 PUTLAM
DEFINE !select  24 PUTLAM

* prompt mode

DEFINE prompt?  25 GETLAM
DEFINE prompt2? 27 GETLAM
DEFINE prompt4? 29 GETLAM
DEFINE prompt5? 30 GETLAM

DEFINE !prompt? 25 PUTLAM

* save choose box font flag

DEFINE fntfl    26 GETLAM
DEFINE !fntfl   26 PUTLAM

* precision values

DEFINE xprec    27 GETLAM
DEFINE yprec    28 GETLAM

DEFINE !xprec   27 PUTLAM
DEFINE !yprec   28 PUTLAM

* current top value for help browser

DEFINE hlptop   29 GETLAM
DEFINE !hlptop  29 PUTLAM

* various temporaries

DEFINE temp1    30 GETLAM
DEFINE temp2    31 GETLAM
DEFINE temp3    32 GETLAM
DEFINE temp4    33 GETLAM
DEFINE temp5    34 GETLAM
DEFINE temp6    35 GETLAM

DEFINE !temp1   30 PUTLAM
DEFINE !temp2   31 PUTLAM
DEFINE !temp3   32 PUTLAM
DEFINE !temp4   33 PUTLAM
DEFINE !temp5   34 PUTLAM
DEFINE !temp6   35 PUTLAM

* vertical screen dimensions

DEFINE scrh-8	36 GETLAM
DEFINE scrh-9   37 GETLAM
DEFINE scrh-13  38 GETLAM

* calc version, if set then 49G+/50G

DEFINE ver+?	39 GETLAM

* helper routines ************************************************************

NULLNAME Prec ( % % -> % )
::
  SWAP DUP %0= ITE DROP ::
    %EXPONENT %CHS %+ DUP %0< IT ::
      DROP %0
    ;
  ;
;

NULLNAME Round ( %x %prec -> %x' )
::
  RNDXY
;

NULLNAME Floor ( %x %prec -> %x' )
::
  %ALOG SWAPOVER %* %FLOOR SWAP %/
;

NULLNAME Ceil ( %x %prec -> %x' )
::
  %ALOG SWAPOVER %* %CEIL SWAP %/
;

NULLNAME %ANGLERAD
::
  SWAP %>%% SWAP %>%% %%ANGLERAD %%>%
;

* trim a line to fit into the display range

DEFINE x1       9GETLAM
DEFINE y1       8GETLAM
DEFINE x2       7GETLAM
DEFINE y2       6GETLAM
DEFINE xmx      5GETLAM
DEFINE ymx      4GETLAM
DEFINE m        3GETLAM
DEFINE b        2GETLAM
DEFINE c        1GETLAM

DEFINE !x1      9PUTLAM
DEFINE !y1      8PUTLAM
DEFINE !x2      7PUTLAM
DEFINE !y2      6PUTLAM
DEFINE !xmx     5PUTLAM
DEFINE !ymx     4PUTLAM
DEFINE !m       3PUTLAM
DEFINE !b       2PUTLAM
DEFINE !c       1PUTLAM

NULLNAME TrimLine ( C% C% -> C% C% )
::
  SWAP C%>% ROT C%>%
  xmax UNCOERCE ymax UNCOERCE
  %0 %0 %0
  ' NULLLAM NINE NDUPN DOBIND
  ::
    x1 x2 %= case ::
      y1 %0< IT :: %0 !y1 ;
      y1 ymx %> IT :: ymx !y1 ;
      y2 %0< IT :: %0 !y2 ;
      y2 ymx %> IT :: ymx !y2 ;
    ;
    y1 y2 %= case ::
      x1 %0< IT :: %0 !x1 ;
      x1 xmx %> IT :: xmx !x1 ;
      x2 %0< IT :: %0 !x2 ;
      x2 xmx %> IT :: xmx !x2 ;
    ;
    y2 y1 %- x2 x1 %- %/ !m
    y1 m x1 %* %- !b
    m xmx %* b %+ !c
    b %0 %>= b ymx %<= AND IT ::
      x1 %0< IT :: %0 !x1 b !y1 ;
      x2 %0< IT :: %0 !x2 b !y2 ;
    ;
    c %0 %>= c ymx %<= AND IT ::
      x1 xmx %> IT :: xmx !x1 c !y1 ;
      x2 xmx %> IT :: xmx !x2 c !y2 ;
    ;
    x2 x1 %- y2 y1 %- %/ !m
    x1 m y1 %* %- !b
    m ymx %* b %+ !c
    b %0 %>= b xmx %<= AND IT ::
      y1 %0< IT :: %0 !y1 b !x1 ;
      y2 %0< IT :: %0 !y2 b !x2 ;
    ;
    c %0 %>= c xmx %<= AND IT ::
      y1 ymx %> IT :: ymx !y1 c !x1 ;
      y2 ymx %> IT :: ymx !y2 c !x2 ;
    ;
  ;
  x1 y1 %>C% x2 y2 %>C%
  ABND
;

* complex addition and subtraction

NULLNAME C%+
::
  C%>% ROT C%>% 2SWAP ( x1 y1 x2 y2 )
  ROTSWAP ( x1 x2 y1 y2 )
  %+ UNROT %+ SWAP ( x y )
  %>C%
;

NULLNAME C%-
::
  C%>% ROT C%>% 2SWAP ( x1 y1 x2 y2 )
  ROTSWAP ( x1 x2 y1 y2 )
  %- UNROT %- SWAP ( x y )
  %>C%
;

* list difference

NULLNAME ListDiff ( {} {} -> {} )
::
  1LAMBIND
  ' ::
    5GETLAM matchob? DROP
  ; ListMap
  ABND
;

* display operations *********************************************************

* max display dimension

DEFINE MAXDIM   400

* width (= height) of cursor and node grobs
* NOTE: must be the same in the current implementation

DEFINE CURSW    TWO
DEFINE NODEW    TWO

* various hard-coded grobs

NULLNAME NODEGRB
GROB 00014 5000050000E0F1F1F1E0
* 7x7 GROB 00018 7000070000C1E3F7F7F7E3C1

NULLNAME CIRCGRB
GROB 00014 5000050000E0111111E0
* 7x7 GROB 00018 7000070000C12214141422C1

NULLNAME ICIRCGRB
GROB 00014 500005000000E0E0E000

NULLNAME CROSSGRB
GROB 00014 50000500004040F14040

NULLNAME MARKGRB
GROB 00014 500005000000A040A000

* translate between user and display coordinates

NULLNAME GRWDispCoords ( C% -> #x #y )
::
  C%>%
  SWAP wxmin %- wxr %/ COERCE
  SWAP wymin %- wyr %/ COERCE ymax NODEW DUP #+ #- SWAP#-
;

NULLNAME GRWUserCoords ( #x #y -> C% )
::
  SWAP UNCOERCE wxr %* wxmin %+
  SWAP ymax NODEW DUP #+ #- SWAP#- UNCOERCE wyr %* wymin %+
  %>C%
;

NULLNAME GRWCursorCoords ( -> C% )
::
  x CURSW #- y CURSW #- GRWUserCoords
;

* check whether a node position in user coords is in the display range

NULLNAME GRWValid ( C% -> T|F )
::
  C%>% SWAP
  ( check x coordinate )
  wxmin %- DUP %0 %< case2drpfls
  wxr %/ %0 RNDXY xmax NODEW DUP #+ #- UNCOERCE %> casedrpfls
  ( check y coordinate )
  wymin %- DUP %0 %< casedrpfls
  wyr %/ %0 RNDXY ymax NODEW DUP #+ #- UNCOERCE %> NOT
;

* locate nodes

* KLUDGE ALERT: we need a special version of GRWDispCoords here, for use
* inside the nested ListMap2 environment

DEFINE wxmin5   12GETLAM
DEFINE wxmax5   13GETLAM
DEFINE wymin5   14GETLAM
DEFINE wymax5   15GETLAM
DEFINE wxr5     16GETLAM
DEFINE wyr5     17GETLAM

DEFINE x5       6GETLAM
DEFINE y5       7GETLAM
DEFINE xmax5    8GETLAM
DEFINE ymax5    9GETLAM

NULLNAME GRWDispCoords5 ( C% -> #x #y )
::
  C%>%
  SWAP wxmin5 %- wxr5 %/ COERCE
  SWAP wymin5 %- wyr5 %/ COERCE ymax5 NODEW DUP #+ #- SWAP#-
;

* GRWFindNode: ( -> node T | F )
* locate the node at the current cursor position; return corresponding node
* index and TRUE, or FALSE if none

NULLNAME GRWFindNode
::
  DUPNULLCOMP? caseFALSE ( empty graph )
  ( construct list { { node dist^2 } ... } of candidate nodes )
  DUP ' ::
    ( get display coordinates of current node )
    GRNodePoint GRWDispCoords5
    ( check whether reference point matches )
    SWAP x5 CURSW #- 2DUP #< IT SWAP #- ( #dx )
    DUP #2 #>case 3DROP ( outside x range )
    SWAP y5 CURSW #- 2DUP #< IT SWAP #- ( #dy )
    DUP #2 #>case 3DROP ( outside y range )
    OVER #2 #= OVER #2 #= AND case 3DROP ( dx=dy=2, outside range )
    ( stack now: #node #dx #dy, compute squared distance )
    SWAP UNCOERCE DUP %* SWAP UNCOERCE DUP %* %+
    TWO{}N
  ; ListMap2
  DUPNULLCOMP? casedrpfls ( no candidates )
  ( find node with smallest distance from reference point )
  ' :: INCOMPDROP SWAPDROP ; ListMin
  INCOMPDROP DROP UNCOERCE TRUE
;

* basic drawing routines

* compute the true display coordinates of a node

NULLNAME GRWDispPoint ( C% -> C% )
::
  C%>%
  SWAP wxmin %- wxr %/ NODEW UNCOERCE %+
  SWAP wymin %- wyr %/ ymax UNCOERCE NODEW UNCOERCE DUP %+ %- SWAP %-
  NODEW UNCOERCE %+
  %>C%
;

* compute the line representing an edge, with offsets from the two endpoints

* I tried several alternatives here, the first one below looks the best, IMHO.

NULLNAME GRWVect ( C% C% -> C% C% )
::
  2DUP SWAP C%- C%>% ( z1 z2 dx dy )
  SWAP DUP %0< ITE :: %CHS TRUE ; FALSE
  ROT DUP %0< ITE :: %CHS TRUE ; FALSE ( z1 z2 |dx| negx? |dy| negy? )
  4ROLLROT ( z1 z2 negx? negy? |dx| |dy| )
  ::
    %ANGLERAD %PI %/ %10 %*
    DUP %4 %> case :: DROP %0 %3 ;
    DUP %3 %> case :: DROP %1 %3 ;
    DUP %2 %> case :: DROP %2 %2 ;
    DUP %1 %> case :: DROP %3 %1 ;
    DROP %3 %0
  ;
  ( z1 z2 negx? negy? |dx'| |dy'| )
  ROT IT %CHS
  ( z1 z2 negx? |dx'| dy' )
  SWAPROT IT %CHS SWAP
  ( z1 z2 dx' dy' )
  %>C% ( z1 z2 dz' )
  ROT OVER C%+ ( z2 dz' z1+dz' )
  UNROT C%- ( z1+dz' z2-dz' )
;

* NULLNAME GRWVect ( C% C% -> C% C% )
* ::
*   2DUP SWAP C%- DUP C%ABS %3 SWAP %/ SWAP C%>%
*   SWAP 3PICK %* COERCE UNCOERCE
*   SWAPROT %* COERCE UNCOERCE
*   %>C%
*   ROT OVER C%+
*   UNROT C%-
* ;

* NULLNAME GRWVect ( C% C% -> C% C% )
* ::
*   2DUP SWAP C%- C%>% ( z1 z2 dx dy )
*   SWAP DUP %0< ITE :: %CHS TRUE ; FALSE
*   ROT DUP %0< ITE :: %CHS TRUE ; FALSE ( z1 z2 |dx| negx? |dy| negy? )
*   4ROLLROT ( z1 z2 negx? negy? |dx| |dy| )
*   ::
*     2DUP %= case :: 2DROP %2 %2 ;
*     2DUP %< case :: DROP %3 %< ITE %0 %1 %3 ;
*     SWAPDROP %3 %< ITE %0 %1 %3 SWAP
*   ;
*   ( z1 z2 negx? negy? |dx'| |dy'| )
*   ROT IT %CHS
*   ( z1 z2 negx? |dx'| dy' )
*   SWAPROT IT %CHS SWAP
*   ( z1 z2 dx' dy' )
*   %>C% ( z1 z2 dz' )
*   ROT OVER C%+ ( z2 dz' z1+dz' )
*   UNROT C%- ( z1+dz' z2-dz' )
* ;

* draw a line (given in true display coordinates encoded as complex values)

NULLNAME GRWDrawLine ( C% C% -> )
::
  SWAP C%>% SWAP COERCE SWAP COERCE
  ROT C%>% SWAP COERCE SWAP COERCE
  HARDBUFF 5UNROLL LineB DROP
;

* delete a line by redrawing it in xor mode
  
NULLNAME GRWDelLine ( C% C% -> )
::
  SWAP C%>% SWAP COERCE SWAP COERCE
  ROT C%>% SWAP COERCE SWAP COERCE
  HARDBUFF 5UNROLL LineXor DROP
;

* draw an arrow head at the center point of a line

NULLNAME GRWDrawArrow ( C% C% -> )
::
  ( compute normalized delta vector )
  2DUP C%- DUP C%ABS DUP %0= case 4DROP
  SWAP C%>% SWAP 3PICK %/ SWAPROT %/ 2DUP %>C% !temp1
  ( multiply by 2 )
  SWAP %2 %* SWAP %2 %* %>C%
  ( place above end points )
  UNROT
  ( compute the center point of the line )
  SWAPOVER C%- temp1 C%- C%>% SWAP %2 %/ SWAP %2 %/ %>C% C%+
  ( shift a little towards the end point )
  OVER C%- SWAP
  ( rotate arrowhead vect by 45 degrees, draw )
  2DUP C% 1 1 ' x* EvalNoCK OVER SWAP C%+ GRWDrawLine
  ( draw again for -45 deg )
  C% 1 -1 ' x* EvalNoCK OVER SWAP C%+ GRWDrawLine
  ( purge temporary )
  ZERO !temp1
;

NULLNAME GRWDelArrow ( C% C% -> )
::
  2DUP C%- DUP C%ABS DUP %0= case 4DROP
  SWAP C%>% SWAP 3PICK %/ SWAPROT %/ 2DUP %>C% !temp1
  SWAP %2 %* SWAP %2 %* %>C%
  UNROT
  SWAPOVER C%- temp1 C%- C%>% SWAP %2 %/ SWAP %2 %/ %>C% C%+
  OVER C%- SWAP
  2DUP C% 1 1 ' x* EvalNoCK OVER SWAP C%+ GRWDelLine
  C% 1 -1 ' x* EvalNoCK OVER SWAP C%+ GRWDelLine
  ZERO !temp1
;

* draw a line label

NULLNAME TAG>$
::
  STRIPTAGS DO>STR DUPLEN$ SEVEN #> IT ::
    SEVEN 1_#1-SUB$ "\1F" &$
  ;
;

NULLNAME RightGrob ( grob x y -> grob' x' y )
::
  UNROT OVER GROBDIM
  ( y grob x ht wd )
  SWAP #1- UNROT #1-
  ( y grob ht-1 x wd-1 )
  2DUP #< ITE ::
    DUPROT #-
    ( y grob ht-1 wd-1 x1=wd-1-x )
    ZERO ROT
    ( y grob ht-1 x1=wd-1-x y1=0 x2=wd-1 )
    4ROLL
    ( y grob x1=wd-1-x y1=0 x2=wd-1 y2=ht-1 )
    SUBGROB
    ( y grob' )
    ONE ROT
    ( grob' x'=1 y )
  ;
  ::
    #1- #- SWAPDROP ROT
  ;
;

NULLNAME CenterGrob ( grob x y -> grob' x' y )
::
  UNROT OVER GROBDIM
  ( y grob x ht wd )
  SWAP #1- UNROT DUP #1- UNROT #2/
  ( y grob ht-1 wd-1 x wd/2 )
  2DUP #< ITE ::
    SWAP #-
    ZERO ROT
    4ROLL
    SUBGROB
    ONE ROT
  ;
  ::
    ROTDROP #1- #- SWAPDROP ROT
  ;
;

NULLNAME BottomGrob ( grob x y -> grob' x y' )
::
  ROTSWAP OVER GROBDIM
  ( x grob y ht wd )
  #1- UNROT #1-
  ( x grob wd-1 y ht-1 )
  2DUP #< ITE ::
    ZERO 4UNROLL
    ( x grob x1=0 x2=wd-1 y y2=ht-1 )
    DUPROT #-
    ( x grob x1=0 x2=wd-1 y2=ht-1 y1=ht-1-y )
    UNROT
    ( x grob x1=0 y1=ht-1-y x2=wd-1 y2=ht-1 )
    SUBGROB
    ( x grob' )
    SWAP ONE
    ( grob' x y'=1 )
  ;
  ::
    #1- #- SWAPDROP ROTSWAP
  ;
;

NULLNAME GRWDrawLineLabel ( label C% C% -> )
::
  ( check orientation, we need these to properly align the label below )
  OVER C%>% 3PICK C%>% ROTSWAP %- UNROT %-
  DUP %0= ITE DROPDUP
  ::
    SWAP DUP %0= IT DROPDUP
  ;
  SWAP %0> SWAP %0< 2SWAP
  ( compute normalized delta vector )
  2DUP C%- DUP C%ABS DUP %0= case 5DROP
  SWAP C%>% SWAP 3PICK %/ SWAPROT %/
  ( multiply by 4 )
  SWAP %4 %* SWAP %4 %* %>C%
  ( rotate -90 deg )
  C% 0 -1 ' x* EvalNoCK UNROT
  ( shift center point by delta vector )
  SWAPOVER C%- C%>% SWAP %2 %/ SWAP %2 %/ %>C% C%+ C%+
  ( prepare label to be drawn )
  C%>% SWAP COERCE SWAP COERCE 5ROLL TAG>$ $>grob UNROT
  4ROLL IT RightGrob
  4ROLL IT BottomGrob
  ( draw it )
  HARDBUFF 4UNROLL Gor DROP
;

* graph drawing routines

* draw a node

NULLNAME GRWDrawNode ( C% -> )
::
  DUP GRWValid ITE ::
    GRWDispCoords HARDBUFF UNROT NODEGRB UNROT Gor DROP
  ;
  DROP
;

* draw a selected node

NULLNAME GRWDrawSelNode ( C% -> )
::
  DUP GRWValid ITE ::
    GRWDispCoords HARDBUFF UNROT CIRCGRB UNROT Gor DROP
  ;
  DROP
;

* draw a selection

NULLNAME GRWDrawSel ( C% -> )
::
  DUP GRWValid ITE ::
    GRWDispCoords HARDBUFF UNROT ICIRCGRB UNROT Gxor DROP
  ;
  DROP
;

* draw a node number/label

NULLNAME GRWDrawNum ( C% node -> )
::
  OVER GRWValid ITE ::
    HARDBUFF SWAP COERCE #>$ $>grob ROT GRWDispCoords
    SWAP SEVEN #+ SWAP
    Gor DROP
  ;
  2DROP
;

NULLNAME GRWDrawLabel ( C% label -> )
::
  OVER GRWValid ITE ::
    HARDBUFF SWAP TAG>$ $>grob ROT GRWDispCoords
    SWAP SEVEN #+ SWAP
    Gor DROP
  ;
  2DROP
;

NULLNAME GRWDrawNumWithLabel ( C% node label -> )
::
  3PICK GRWValid ITE ::
    HARDBUFF UNROT TAG>$ SWAP COERCE #>$ APPEND_SPACE SWAP &$
    $>grob ROT GRWDispCoords
    SWAP SEVEN #+ SWAP
    Gor DROP
  ;
  2DROP
;

* draw a loop

NULLNAME GRWDrawLoop ( C% -> )
::
  DUP GRWValid NOTcase DROP
  GRWDispCoords
  SWAP NODEW #+ SWAP NODEW #+
  THREE #+ FOUR HARDBUFF 4UNROLL CircleB DROP
;

NULLNAME GRWDrawLoopWithLabel ( label C% -> )
::
  DUP GRWValid NOTcase 2DROP
  GRWDispCoords
  SWAP NODEW #+ SWAP NODEW #+
  2DUP THREE #+ FOUR HARDBUFF 4UNROLL CircleB DROP
  ROT TAG>$ $>grob UNROT NINE #+ CenterGrob
  HARDBUFF 4UNROLL Gor DROP  
;

* draw an undirected edge

NULLNAME GRWDrawEdge ( C% C% -> )
::
  OVER GRWValid NOT
  OVER GRWValid NOT 2DUP ANDcase 4DROP
  OR UNROT
  SWAP GRWDispPoint SWAP GRWDispPoint
  2DUP C%- C%ABS COERCE SIX #< case 3DROP
  GRWVect ROT IT TrimLine
  GRWDrawLine
;

NULLNAME GRWDrawEdgeWithLabel ( label C% C% -> )
::
  OVER GRWValid NOT
  OVER GRWValid NOT 2DUP ANDcase 5DROP
  OR UNROT
  SWAP GRWDispPoint SWAP GRWDispPoint
  2DUP C%- C%ABS COERCE SIX #< case 4DROP
  GRWVect ROT IT TrimLine
  2DUP GRWDrawLine GRWDrawLineLabel
;

* draw a directed edge

NULLNAME GRWDelArc ( C% C% -> )
::
  OVER GRWValid NOT
  OVER GRWValid NOT 2DUP ANDcase 4DROP
  OR UNROT
  SWAP GRWDispPoint SWAP GRWDispPoint
  2DUP C%- C%ABS COERCE SIX #< case 3DROP
  GRWVect ROT IT TrimLine
  GRWDelArrow
;

NULLNAME GRWDrawArc ( C% C% -> )
::
  OVER GRWValid NOT
  OVER GRWValid NOT 2DUP ANDcase 4DROP
  OR UNROT
  SWAP GRWDispPoint SWAP GRWDispPoint
  2DUP C%- C%ABS COERCE SIX #< case 3DROP
  GRWVect ROT IT TrimLine
  2DUP GRWDrawLine GRWDrawArrow
;

NULLNAME GRWDrawArcWithLabel ( label C% C% -> )
::
  OVER GRWValid NOT
  OVER GRWValid NOT 2DUP ANDcase 5DROP
  OR UNROT
  SWAP GRWDispPoint SWAP GRWDispPoint
  2DUP C%- C%ABS COERCE SIX #< case 4DROP
  GRWVect ROT IT TrimLine
  2DUP GRWDrawLine 2DUP GRWDrawArrow GRWDrawLineLabel
;

* draw a node together with its edges

NULLNAME GRWDrawNodeWithEdges ( node node-info -> node )
::
  temp5 !temp6
  ( split the source node )
  GRSplitNode
  ( stack now: node point labels edges )
  ( draw the node )
  3PICK GRWDrawNode
  ( draw the node label )
  SWAP DUPNULLCOMP? wnlbl? NOT OR ITE ::
    DROP wnum? IT ::
      OVER 4PICK GRWDrawNum
    ;
  ;
  ::
    CARCOMP wnum? ITE ::
      3PICK SWAP 5PICK SWAP GRWDrawNumWithLabel
    ;
    ::
      3PICK SWAP GRWDrawLabel
    ;
  ;
  ( stack now: node point edges )
  ( draw the edges )
  DUPNULLCOMP? case 2DROP
  >R 'R
  [BEGIN]
    GRSplitEdge ( node point target labels )
    temp6 3PICK COERCE NTHCOMPDROP ( edge already drawn? )
    ITE 2DROP ::
      temp2 3PICK COERCE NTHCOMPDROP
      temp3 4PICK COERCE NTHCOMPDROP
      ( node point target labels target-point target-targets )
      6PICK 5PICK %= ITE ::
	( loop )
	DROPSWAP DUPNULLCOMP? NOT welbl? AND ITE ::
	  CARCOMP SWAP GRWDrawLoopWithLabel
	;
	::
	  DROP GRWDrawLoop
	;
      ;
      ::
	( ordinary edge; check whether it's symmetric )
	6PICK EQUALPOSCOMP DUP#0<> ITE ::
	  ( node point target labels target-point pos )
	  ( only need to draw the edge once )
	  4PICK 7PICK %> ITE 3DROP ::
	    welbl? ITE ::
	      temp4 5PICK COERCE NTHCOMPDROP SWAP NTHCOMPDROP ROT
	      ( node point target target-point rlabel labels )
	      DUPNULLCOMP? ITE ::
		DROP DUPTYPETAG? ITE ::
		  SWAP 4PICK GRWDrawEdgeWithLabel
		;
		::
		  DROP 3PICK SWAP GRWDrawEdge
		;
	      ;
	      ::
		CARCOMP 2DUP EQUAL ITE ::
		  SWAPDROP SWAP 4PICK SWAP GRWDrawEdgeWithLabel
		;
		::
		  5PICK 4PICK GRWDrawEdgeWithLabel
		  DUPTYPETAG? ITE ::
		    SWAP 4PICK GRWDrawEdgeWithLabel
		  ;
		  2DROP
		;
	      ;
	    ;
	    ::
	      DROP SWAPDROP 3PICK SWAP GRWDrawEdge
	    ;
	  ;
	;
	::
	  DROPSWAP DUPNULLCOMP? NOT welbl? AND ITE ::
	    CARCOMP SWAP 4PICK SWAP GRWDrawArcWithLabel
	  ;
	  ::
	    DROP 3PICK SWAP GRWDrawArc
	  ;
	;
      ;
      ( record drawn edge )
      TRUE SWAP COERCE temp6 PUTLIST !temp6
    ;
    RSWAP ticR
  [WHILE]
    RSWAP
  [REPEAT]
  DROP
;

* draw the graph

NULLNAME GRWDrawGraph
::
  ( this is essentially a ListDo, but we want to avoid an extra env here )
  DUPNULLCOMP? ?SEMI
  DUP ' GRNodePoint ListMap !temp2
  DUP ' GRNodeAdj ListMap !temp3
  DUP ' :: GRNodeEdges ' :: GREdgeLabels CARCOMP ; ListMap ; ListMap !temp4
  FALSE OVER LENCOMP NDUPN {}N !temp5
  %0 OVER >R 'R
  [BEGIN]
    SWAP %1+ SWAP
    GRWDrawNodeWithEdges
    RSWAP ticR
  [WHILE]
    RSWAP
  [REPEAT]
  DROP
  ZEROZEROZERO !temp2 !temp3 !temp4
  ZEROZERO !temp5 !temp6
  ( draw the selection )
  select GRWDrawSelect
;

* draw the cursor and the mark (xor mode)

NULLNAME GRWDrawCursor ( -> )
::
  HARDBUFF CROSSGRB x CURSW #- y CURSW #- Gxor DROP
;

NULLNAME GRWDrawMark ( C% -> )
::
  GRWDispCoords HARDBUFF UNROT MARKGRB UNROT Gxor DROP
;

* display management *********************************************************

* initialize display, switch to the graphics screen
NULLNAME GRWInitDisp
::
  RECLAIMDISP
  ClrDA1IsStat
  GRWSetSize
  GRWResize
;

* finalize display, switch back to text screen
NULLNAME GRWFiniDisp
::
  RECLAIMDISP
  ClrDAsOK
  KILLGDISP
;

* switch over to the text display, initialized from the appropriate range in
* the graph display
NULLNAME GRWTextDisp
::
  GBUFF xwin ywin xwin 131 #+ ywin scrh-8 #+ SUBGROB
  ABUFF ZEROZERO GROB! TOADISP
;

* switch back to the graph display
NULLNAME GRWGraphDisp
::
  TOGDISP
;

* set new display size
NULLNAME GRWSetSize ( -> )
::
  wxmax wxmin %- wxr %/ %CEIL COERCE NODEW DUP #+ #+
  DUP 130 #< IT :: DROP 130 ; !xmax
  wymax wymin %- wyr %/ %CEIL COERCE NODEW DUP #+ #+
  DUP scrh-9 #< IT :: DROP scrh-9 ; !ymax
;

NULLNAME GRWResize ( -> )
::
  KILLGDISP ymax #1+ xmax #1+ MAKEGROB GROB>GDISP
  TOGDISP
  ywin xwin WINDOWXY
  GRWDraw
;

* redraw the graph display, switch to graph screen
NULLNAME GRWRedraw ( -> )
::
  TOGDISP CLEARVDISP GRWDraw
;

NULLNAME GRWDraw ( -> )
::
  ( draw the graph )
  GRWDrawGraph
  ( force garbage collection )
  GARBAGE
  ( display the mark if necessary )
  coord? IT ::
    mark %0> IT ::
      DUP mark GRGetNode GRNodePoint GRWDrawMark
    ;
  ;
  ( display the cursor )
  GRWDrawCursor
;

* cursor control **************************************************************

* GRWCursorUp ( -> ): move the cursor up (with autorepeat/scroll)
NULLNAME GRWCursorUp
::
  BEGIN
    ver+? IT :: slowdown ;
    y NODEW #> ITE
    ::
      GRWDrawCursor
      y #1- DUP !y
      ywin #< IT :: WINDOWUP ywin #1- !ywin ;
      GRWDrawCursor
    ;
    ::
      ywin #0=?SKIP :: WINDOWUP ywin #1- !ywin ;
    ;
    kcUpArrow REPKEY? NOT
  UNTIL
;

* GRWCursorDown ( -> ): move the cursor down (with autorepeat/scroll)
NULLNAME GRWCursorDown
::
  BEGIN
    ver+? IT :: slowdown ;
    y ymax NODEW #- #< ITE
    ::
      GRWDrawCursor
      y #1+ DUP !y
      ywin scrh-9 #+ #> IT :: WINDOWDOWN ywin #1+ !ywin ;
      GRWDrawCursor
    ;
    ::
      ywin scrh-9 #+ ymax #=?SKIP :: WINDOWDOWN ywin #1+ !ywin ;
    ;
    kcDownArrow REPKEY? NOT
  UNTIL
;

* GRWCursorLeft ( -> ): move the cursor left (with autorepeat/scroll)
NULLNAME GRWCursorLeft
::
  BEGIN
    ver+? IT :: slowdown ;
    x NODEW #> ITE
    ::
      GRWDrawCursor
      x #1- DUP !x
      xwin #< IT :: WINDOWLEFT xwin #1- !xwin ;
      GRWDrawCursor
    ;
    ::
      xwin #0=?SKIP :: WINDOWLEFT xwin #1- !xwin ;
    ;
    kcLeftArrow REPKEY? NOT
  UNTIL
;

* GRWCursorRight ( -> ): move the cursor right (with autorepeat/scroll)
NULLNAME GRWCursorRight
::
  BEGIN
    ver+? IT :: slowdown ;
    x xmax NODEW #- #< ITE
    ::
      GRWDrawCursor
      x #1+ DUP !x
      xwin 130 #+ #> IT :: WINDOWRIGHT xwin #1+ !xwin ;
      GRWDrawCursor
    ;
    ::
      xwin 130 #+ xmax #=?SKIP :: WINDOWRIGHT xwin #1+ !xwin ;
    ;
    kcRightArrow REPKEY? NOT
  UNTIL
;

* GRWCursorTop ( -> ): move the cursor to the top of the window
NULLNAME GRWCursorTop
::
  GRWDrawCursor
  ywin
  DUP NODEW #< IT :: DROP NODEW ;
  !y
  GRWDrawCursor
;

* GRWCursorBegin ( -> ): move the cursor to the beginning of the window
NULLNAME GRWCursorBegin
::
  GRWDrawCursor
  xwin
  DUP NODEW #< IT :: DROP NODEW ;
  !x
  GRWDrawCursor
;

* GRWCursorEnd ( -> ): move the cursor to the bottom of the window
NULLNAME GRWCursorEnd
::
  GRWDrawCursor
  xwin 130 #+
  xmax NODEW #- 2DUP #> IT SWAP DROP
  !x
  GRWDrawCursor
;

* GRWCursorBottom ( -> ): move the cursor to the bottom of the window
NULLNAME GRWCursorBottom
::
  GRWDrawCursor
  ywin scrh-9 #+
  ymax NODEW #- 2DUP #> IT SWAP DROP
  !y
  GRWDrawCursor
;

* GRWCursorDTop ( -> ): move the cursor to the top of the display
NULLNAME GRWCursorDTop
::
  GRWDrawCursor
  ZERO !ywin CURSW !y
  ywin xwin WINDOWXY
  GRWDrawCursor
;

* GRWCursorDBegin ( -> ): move the cursor to the beginning of the display
NULLNAME GRWCursorDBegin
::
  GRWDrawCursor
  ZERO !xwin CURSW !x
  ywin xwin WINDOWXY
  GRWDrawCursor
;

* GRWCursorDEnd ( -> ): move the cursor to the end of the display
NULLNAME GRWCursorDEnd
::
  GRWDrawCursor
  xmax 130 #- !xwin xmax CURSW #- !x
  ywin xwin WINDOWXY
  GRWDrawCursor
;

* GRWCursorDBottom ( -> ): move the cursor to the bottom of the display
NULLNAME GRWCursorDBottom
::
  GRWDrawCursor
  ymax scrh-9 #- !ywin ymax CURSW #- !y
  ywin xwin WINDOWXY
  GRWDrawCursor
;

* zoom ***********************************************************************

* GRWZoomCheck ( % -> T|F )
NULLNAME GRWZoomCheck
::
  DUP %1 %< case ::
    wxmax wxmin %- DUP %0= ITE DROPTRUE ::
      MAXDIM UNCOERCE %/ OVER wxr %* %> NOT
    ;
    ITE ::
      wymax wymin %- DUP %0= ITE DROPTRUE ::
        MAXDIM UNCOERCE %/ OVER wyr %* %> NOT
      ;
      SWAPDROP
    ;
    DROPFALSE
  ;
  DUP %1 %> casedrop ::
    wxmax wxmin %- DUP %0= ITE DROPTRUE :: wxr %> ;
    ITE ::
      wymax wymin %- DUP %0= ITE DROPTRUE :: wyr %> ;
      ITE ::
        wxmax wxmin %- wxr %/ %CEIL COERCE NODEW DUP #+ #+ 130 #< NOT
        ITE TRUE
        ::
          wymax wymin %- wyr %/ %CEIL COERCE NODEW DUP #+ #+ scrh-9 #< NOT
        ;
      ;
      FALSE
    ;
    FALSE
  ;
  DROPFALSE
;

* GRWZoomUpdate ( yofs xofs cursor-coords -> )
NULLNAME GRWZoomUpdate
::
  GRWDispCoords
  CURSW #+ DUP ymax CURSW #- #> IT :: DROP CURSW ; !y
  CURSW #+ DUP xmax CURSW #- #> IT :: DROP xmax CURSW #- ; !x
  x CURSW #< IT :: CURSW !x ;
  y CURSW #< IT :: CURSW !y ;
  x 2DUP #< ITE SWAP#- :: 2DROP ZERO ; !xwin
  y 2DUP #< ITE SWAP#- :: 2DROP ZERO ; !ywin
  xmax 130 #- DUP xwin #< ITE !xwin DROP
  ymax scrh-9 #- DUP ywin #< ITE !ywin DROP
;

* GRWZoomIn ( -> ): zoom in by zoom factor
NULLNAME GRWZoomIn
::
  ( check display parameters )
  wz %1/ GRWZoomCheck NOTcase ERRBEEP
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( update resolution values )
  wxr wz %/ !wxr
  wyr wz %/ !wyr
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw the display )
  GRWResize
;

* GRWZoomOut ( -> ): zoom out by zoom factor
NULLNAME GRWZoomOut
::
  ( check display parameters )
  wz GRWZoomCheck NOTcase ERRBEEP
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( update resolution values )
  wxr wz %* !wxr
  wyr wz %* !wyr
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw the display )
  GRWResize
;

NULLNAME GRWNodeRange ( graph -> )
::
  %-MAXREAL %MAXREAL %-MAXREAL %MAXREAL
  ' NULLLAM FOUR NDUPN DOBIND
  ' ::
    GRNodePoint C%>%
    DUP 5GETLAM %< IT :: DUP 5PUTLAM ;
    DUP 6GETLAM %> IT :: DUP 6PUTLAM ;
    DROP
    DUP 3GETLAM %< IT :: DUP 3PUTLAM ;
    DUP 4GETLAM %> IT :: DUP 4PUTLAM ;
    DROP
  ; ListDo
  1GETLAM 2GETLAM 3GETLAM 4GETLAM ABND
;

* NULLNAME GRWSetRange
* ::
*   !wymax !wymin !wxmax !wxmin
*   wxmax wxmin %- %2 Prec !xprec
*   wymax wymin %- %2 Prec !yprec
*   wxmin xprec Floor !wxmin
*   wxmax xprec Ceil !wxmax
*   wymin yprec Floor !wymin
*   wymax yprec Ceil !wymax
*   wxmin wxmax %= ITE % 1e-2 ::
*     wxmax wxmin %- % 126 %/ xprec Ceil
*   ;
*   !wxr
*   wymin wymax %= ITE % 1e-2 ::
*     wymax wymin %- scrh-13 UNCOERCE %/ yprec Ceil
*   ;
*   !wyr
* ;

NULLNAME GRWSetRange
::
  !wymax !wymin !wxmax !wxmin
  wxmin wxmax %= ITE % 1e-2 ::
    wxmax wxmin %- % 126 wnum? IT :: %9 %- ; %/
  ;
  !wxr
  wymin wymax %= ITE % 1e-2 ::
    wymax wymin %- scrh-13 UNCOERCE %/
  ;
  !wyr
;

* GRWFullScreen ( -> ): zoom to full screen display
NULLNAME GRWFullScreen
::
  DUPNULLCOMP? ?SEMI
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( determine range of node coordinates )
  4PICK GRWNodeRange
  ( set the new display range )
  GRWSetRange
  GRWParCheck
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw )
  GRWResize
;

* GRWFullSqrMax ( -> ): zoom to square fullscreen (largest range)
NULLNAME GRWFullSqrMax
::
  DUPNULLCOMP? ?SEMI
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( determine range of node coordinates )
  4PICK GRWNodeRange
  ( set the new display range )
  GRWSetRange
  GRWParCheck
  ( adjust resolution values )
  wxr wyr %MIN DUP !wxr !wyr
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw )
  GRWResize
;

* GRWFullSqrMin ( -> ): zoom to square fullscreen (smallest range)
NULLNAME GRWFullSqrMin
::
  DUPNULLCOMP? ?SEMI
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( determine range of node coordinates )
  4PICK GRWNodeRange
  ( set the new display range )
  GRWSetRange
  GRWParCheck
  ( adjust resolution values )
  wxr wyr %MAX DUP !wxr !wyr
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw )
  GRWResize
;

* GRWZoomRevert ( -> ): revert zoom to GRWPAR settings
NULLNAME GRWZoomRevert
::
  GRWTextDisp
  ( save current cursor offset and user coordinates for later use )
  y ywin #- x xwin #- GRWCursorCoords
  ( set the new display range )
  GRWLoadPar
  GRWParCheck
  ( update cursor position and window )
  GRWSetSize
  GRWZoomUpdate
  ( redraw )
  GRWResize
;

* editing operations and callbacks *******************************************

NULLNAME GRWCreateNode
* create a new node at the current cursor position
::
  prompt? IT GRWTextDisp
  ( get cursor coordinates )
  GRWCursorCoords NULL{} NULL{} GRMakeNode 1LAMBIND
  ( insert new node into graph )
  1GETLAM prompt2? ITE ::
    GRWNodeAdd
    ITE ::
      DUP 1PUTLAM
      TRUE
    ;
    FALSE
  ;
  TRUE
  NOTcase :: FALSE ABND GRWGraphDisp ;
  GRAddNode
  ( draw new node and label )
  DUPLENCOMP UNCOERCE
  1GETABND GRSplitNode DROP
  prompt? IT ::
    GRWGraphDisp GRWDrawCursor
  ;
  OVER GRWDrawNode
  DUPNULLCOMP? wnlbl? NOT OR ITE ::
    DROP wnum? IT ::
      SWAP GRWDrawNum
    ;
  ;
  ::
    CARCOMP wnum? ITE ::
      ROTSWAP GRWDrawNumWithLabel
    ;
    ::
      GRWDrawLabel DROP
    ;
  ;
  ( update edited flag )
  TRUE !edited?
  TRUE
;

NULLNAME GRWNode
::
  ITE ::
    GRWFindNode
    ITE ::
      DROP ERRBEEP
    ;
    ::
      GRWCreateNode NOT ?SEMI
      GRWDrawCursor
    ;
  ;
  GRWResetMode
;

NULLNAME GRWEdge
::
  ITE ::
    GRWFindNode ITE ::
      ( existing node, check for existing edges )
      mark SWAP { NULLLAM NULLLAM } BIND
      DUP 2GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 4GETLAM %<> ; ListDoWhile
      NOTcase :: 1GETABND TRUE ;
      DUP 1GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 5GETLAM %<> ; ListDoWhile
      NOTcase :: 1GETABND TRUE ;
      1GETABND FALSE
    ;
    ::
      ( create a new node at current point )
      GRWCreateNode NOTcase :: %0 TRUE ;
      GRWDrawCursor
      ( return new node number and indicate a new edge )
      DUPLENCOMP UNCOERCE FALSE
    ;
    ITE ::
      ( edge already exists, or no target, error )
      DROP ERRBEEP
    ;
    ::
      ( if we come here, we have to add a new edge to the node in level 1 )
      prompt? IT GRWTextDisp
      mark NULL{} UNROT { NULLLAM NULLLAM NULLLAM } BIND
      2GETLAM NULL{}
      prompt4? ITE ::
        GRMakeEdge GRWEdgeAdd
        ITE :: GRSplitEdge DUP 3PUTLAM OVER 2PUTLAM TRUE ; FALSE
      ;
      TRUE
      NOTcase :: ABND GRWGraphDisp ;
      1GETLAM UNROT GRAddEdge2
      ( draw the new edge )
      DUP 1GETLAM GRGetNode GRNodePoint
      OVER 2GETLAM GRGetNode GRNodePoint
      2GETLAM UNROT 3GETLAM UNROT
      1GETLAM 2GETLAM %= ABND
      prompt? IT GRWGraphDisp
      ( stack now: target labels source-point target-point loop? )
      ITE ::
        ( draw a loop )
        DROP
        ( make sure to redraw mark and cursor here, otherwise we may mess up
          the display )
	DUP GRWDrawMark GRWDrawCursor
	SWAP DUPNULLCOMP? welbl? NOT OR ITE ::
	  DROP DUP GRWDrawLoop
	;
	::
	  CARCOMP OVER GRWDrawLoopWithLabel
	;
	GRWDrawCursor GRWDrawMark
        DROP
      ;
      ::
        ( draw an ordinary edge )
        ( we only have to redraw the cursor here )
        GRWDrawCursor
	2DUP 5ROLL
	DUPNULLCOMP? welbl? NOT OR ITE ::
	  DROP GRWDrawEdge
	;
	::
	  CARCOMP UNROT 6PICK mark %> IT SWAP GRWDrawEdgeWithLabel
	;
        GRWDrawCursor
        ( move mark to new node if in path mode )
        path? ITE ::
          SWAP GRWDrawMark GRWDrawMark !mark
        ;
        3DROP
      ;
      ( graph has been edited )
      TRUE !edited?
    ;
  ;
  ::
    DUP mark GRGetNode GRNodePoint GRWDrawMark GRWResetMode
    %0 !mark
  ;
;

NULLNAME GRWOutEdge
::
  ITE ::
    GRWFindNode ITE ::
      ( existing node, check for existing edges )
      mark SWAP { NULLLAM NULLLAM } BIND
      DUP 2GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 4GETLAM %<> ; ListDoWhile
      NOTcase :: 1GETABND TRUE ;
      DUP 1GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 5GETLAM %<> ; ListDoWhile NOT
      1GETABND SWAP FALSE
    ;
    ::
      ( create a new node at current point )
      GRWCreateNode NOTcase :: %0 TRUE ;
      GRWDrawCursor
      ( return new node number and indicate a new edge )
      DUPLENCOMP UNCOERCE FalseFalse
    ;
    ITE ::
      ( edge already exists, or no target, error )
      DROP ERRBEEP
    ;
    ::
      ( if we come here, we have to add a new edge to the node in level 2,
        and the flag in level 1 denotes whether this edge already has a
	reversal )
      prompt? IT GRWTextDisp
      SWAP mark NULL{} UNROT { NULLLAM NULLLAM NULLLAM NULLLAM } BIND
      2GETLAM NULL{}
      prompt5? ITE ::
        GRMakeEdge GRWEdgeAdd
        ITE :: GRSplitEdge DUP 3PUTLAM OVER 2PUTLAM TRUE ; FALSE
      ;
      TRUE
      NOTcase :: ABND GRWGraphDisp ;
      1GETLAM UNROT GRAddEdge
      ( draw the new edge )
      DUP 1GETLAM GRGetNode GRNodePoint
      OVER 2GETLAM GRGetNode GRNodePoint
      2GETLAM UNROT 3GETLAM UNROT
      4GETLAM 1GETLAM 2GETLAM %= ABND
      prompt? IT GRWGraphDisp
      ( stack now: target labels source-point target-point reversal? loop? )
      ITE ::
        ( draw a loop )
        2DROP
        ( make sure to redraw mark and cursor here, otherwise we may mess up
          the display )
	DUP GRWDrawMark GRWDrawCursor
	SWAP DUPNULLCOMP? welbl? NOT OR ITE ::
	  DROP DUP GRWDrawLoop
	;
	::
	  CARCOMP OVER GRWDrawLoopWithLabel
	;
	GRWDrawCursor GRWDrawMark
        DROP
      ;
      ::
        ( draw an ordinary edge )
        ( we only have to redraw the cursor here )
        GRWDrawCursor
	ITE ::
	  ( draw the old arc in xor mode to delete it )
	  2DUP SWAP GRWDelArc
	  2DUP 5ROLL
	  DUPNULLCOMP? welbl? NOT OR ITE ::
	    DROP GRWDrawEdge
	  ;
	  ::
	    CARCOMP UNROT GRWDrawEdgeWithLabel
	  ;
	;
	::
	  2DUP 5ROLL
	  DUPNULLCOMP? welbl? NOT OR ITE ::
	    DROP GRWDrawArc
	  ;
	  ::
	    CARCOMP UNROT GRWDrawArcWithLabel
	  ;
	;
        GRWDrawCursor
        ( move mark to new node if in path mode )
        path? ITE ::
          SWAP GRWDrawMark GRWDrawMark !mark
        ;
        3DROP
      ;
      ( graph has been edited )
      TRUE !edited?
    ;
  ;
  ::
    DUP mark GRGetNode GRNodePoint GRWDrawMark GRWResetMode
    %0 !mark
  ;
;

NULLNAME GRWInEdge
::
  ITE ::
    GRWFindNode ITE ::
      ( existing node, check for existing edges )
      mark SWAP { NULLLAM NULLLAM } BIND
      DUP 1GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 5GETLAM %<> ; ListDoWhile
      NOTcase :: 1GETABND TRUE ;
      DUP 2GETLAM GRGetNode GRNodeEdges
      ' :: GREdgeTarget 4GETLAM %<> ; ListDoWhile NOT
      1GETABND SWAP FALSE
    ;
    ::
      ( create a new node at current point )
      GRWCreateNode NOTcase :: %0 TRUE ;
      GRWDrawCursor
      ( return new node number and indicate a new edge )
      DUPLENCOMP UNCOERCE FalseFalse
    ;
    ITE ::
      ( edge already exists, or no target, error )
      DROP ERRBEEP
    ;
    ::
      ( if we come here, we have to add a new edge to the node in level 2,
        and the flag in level 1 denotes whether this edge already has a
	reversal )
      prompt? IT GRWTextDisp
      SWAP mark NULL{} UNROT { NULLLAM NULLLAM NULLLAM NULLLAM } BIND
      1GETLAM NULL{}
      prompt5? ITE ::
        GRMakeEdge GRWEdgeAdd
        ITE :: GRSplitEdge DUP 3PUTLAM OVER 1PUTLAM TRUE ; FALSE
      ;
      TRUE
      NOTcase :: ABND GRWGraphDisp ;
      2GETLAM UNROT GRAddEdge
      ( draw the new edge )
      DUP 1GETLAM GRGetNode GRNodePoint
      OVER 2GETLAM GRGetNode GRNodePoint
      2GETLAM UNROT 3GETLAM UNROT
      4GETLAM 1GETLAM 2GETLAM %= ABND
      prompt? IT GRWGraphDisp
      ( stack now: target labels source-point target-point reversal? loop? )
      ITE ::
        ( draw a loop )
        2DROP
        ( make sure to redraw mark and cursor here, otherwise we may mess up
          the display )
	DUP GRWDrawMark GRWDrawCursor
	SWAP DUPNULLCOMP? welbl? NOT OR ITE ::
	  DROP DUP GRWDrawLoop
	;
	::
	  CARCOMP OVER GRWDrawLoopWithLabel
	;
	GRWDrawCursor GRWDrawMark
        DROP
      ;
      ::
        ( draw an ordinary edge )
        ( we only have to redraw the cursor here )
        GRWDrawCursor
	ITE ::
	  ( draw the old arc in xor mode to delete it )
	  2DUP GRWDelArc
	  2DUP 5ROLL
	  DUPNULLCOMP? welbl? NOT OR ITE ::
	    DROP SWAP GRWDrawEdge
	  ;
	  ::
	    CARCOMP UNROT SWAP GRWDrawEdgeWithLabel
	  ;
	;
	::
	  2DUP 5ROLL
	  DUPNULLCOMP? welbl? NOT OR ITE ::
	    DROP SWAP GRWDrawArc
	  ;
	  ::
	    CARCOMP UNROT SWAP GRWDrawArcWithLabel
	  ;
	;
        GRWDrawCursor
        ( move mark to new node if in path mode )
        path? ITE ::
          SWAP GRWDrawMark GRWDrawMark !mark
        ;
        3DROP
      ;
      ( graph has been edited )
      TRUE !edited?
    ;
  ;
  ::
    DUP mark GRGetNode GRNodePoint GRWDrawMark GRWResetMode
    %0 !mark
  ;
;

**** the graph browser ****

NULLNAME GRWBrowser
::
  GRWTextDisp
  FLASHPTR SaveHARDBUFF
  ( get current node, if any )
  GRWFindNode ITE ::
    COERCE #1-
  ;
  ZERO
  ( create menu entries )
  select { LAM sel } BIND
  OVER ' GRWNodeStr ListMap2
  ABND
  ( temporaries )
  ZERO UNROT
  ZERO FALSE GRWCursorCoords select coord?
  ver+? ITE :: SEVEN EIGHT ; :: FIVE SIX ;
  { LAM ofs LAM item LAM list LAM action LAM ed? LAM point LAM sel
    LAM simple? LAM boxh-1 LAM boxh } BIND
  BEGIN
    ZERO ' LAM action STO
    ( show menu )
    ( make sure we have at least a dummy entry )
    LAM list DUPNULLCOMP? IT :: DROP "no entries" ONE{}N ;
    INNERCOMP
    "NODES" LAM item
    ( message handler )
    ::
      LAM simple? case ::
        ( restricted operation in coord mode )
        ' ::
	  THREE OVER#=case GRWBrowserEndInit
	  FOUR OVER#=case ::
            ( key handler )
	    DROP
	    2DUP kpNoShift #= SWAP kcRightArrow #= AND
	    LAM list NULLCOMP? NOT ANDcase ::
	      2DROP ' :: TakeOver SIX GRWBrowserAction ;
	      TrueTrue
	    ;
	    2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	      2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
	      TrueTrue
	    ;
	    2DUP kpNoShift #= SWAP kcSto #= AND
	    LAM list NULLCOMP? NOT ANDcase ::
	      2DROP ' :: TakeOver EIGHT GRWBrowserAction ;
	      TrueTrue
	    ;
            FALSE
          ;
          FIVE OVER#=case ::
            ( menu )
            DROP
            ' ::
              NoExitAction
              { NullMenuKey
                NullMenuKey
                NullMenuKey
                NullMenuKey
                { "CANCL" FLASHPTR Choose3CANCL }
                { "OK"    FLASHPTR Choose3OK }
              }
            ;
            TRUE
          ;
          DROPFALSE
        ;
      ;
      LAM list NULLCOMP? case ::
        ( only allow ADD if graph is empty )
        ' ::
	  FOUR OVER#=case ::
	    ( key handler )
	    DROP
	    2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	      2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
	      TrueTrue
	    ;
	    FALSE
	  ;
          FIVE OVER#=case ::
            ( menu )
            DROP
            ' ::
              NoExitAction
              { NullMenuKey
                { "ADD"   :: TakeOver TWO GRWBrowserAction ; }
                NullMenuKey
                NullMenuKey
                { "CANCL" FLASHPTR Choose3CANCL }
                { "OK"    FLASHPTR Choose3OK }
              }
            ;
            TRUE
          ;
          DROPFALSE
        ;
      ;
      ' ::
        THREE OVER#=case GRWBrowserEndInit
        FOUR OVER#=case ::
          ( key handler )
          DROP
          2DUP kpNoShift #= SWAP kcChs #= ANDcase ::
            2DROP ' :: TakeOver FIVE GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpNoShift #= SWAP kcRightArrow #= ANDcase ::
            2DROP ' :: TakeOver SIX GRWBrowserAction ;
            TrueTrue
          ;
	  2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	    2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
	    TrueTrue
	  ;
          2DUP kpNoShift #= SWAP kcSto #= ANDcase ::
	    2DROP ' :: TakeOver EIGHT GRWBrowserAction ;
            TrueTrue
          ;
          FALSE
        ;
        FIVE OVER#=case ::
          ( menu )
          DROP
          ' ::
            NoExitAction
            { { "EDIT"  :: TakeOver ONE GRWBrowserAction ; }
              { "ADD"   :: TakeOver TWO GRWBrowserAction ; }
              { "DEL"   :: TakeOver THREE GRWBrowserAction ; }
              { "ORDER" :: TakeOver FOUR GRWBrowserAction ; }
              { "CANCL" FLASHPTR Choose3CANCL }
              { "OK"    FLASHPTR Choose3OK }
            }
          ;
          TRUE
        ;
        DROPFALSE
      ;
    ;
    FLASHPTR Choose3
    ( process action )
    ITE ::
      LAM list SWAP EQUALPOSCOMP ' LAM item STO
      TRUE
    ;
    ::
      LAM action
      ZERO #=casedrop ::
        ZERO ' LAM item STO
        TRUE
      ;
      ONE #=casedrop ::
        ( edit the current node )
        LAM item #1+ UNCOERCE OVERSWAP GRGetNode
        ( invoke the node editor )
        GRWNodeEdit
        IT ::
          ( update the graph )
          DUP UNROT LAM item #1+ UNCOERCE SWAP GRSetNode
          ( update the menu entry )
          LAM item #1+ ROT GRWNodeStr
          LAM item #1+ LAM list PUTLIST ' LAM list STO
          TRUE ' LAM ed? STO
        ;
        FALSE
        FLASHPTR RestoreHARDBUFF
      ;
      TWO #=casedrop ::
        ( create a new node )
        LAM point NULL{} NULL{} GRMakeNode
        ( invoke the node editor )
        GRWNodeAdd
        IT ::
          ( update graph and menu )
          DUP UNROT GRAddNode DUPLENCOMP DUP #1- ' LAM item STO
          ROT GRWNodeStr
          LAM list SWAP >TCOMP ' LAM list STO
          TRUE ' LAM ed? STO
        ;
        FALSE
        FLASHPTR RestoreHARDBUFF
      ;
      THREE #=casedrop ::
        ( delete the selected nodes )
        ( determine list of nodes to be deleted )
        LAM sel DUPNULLCOMP? IT ::
          DROP LAM item #1+ UNCOERCE ONE{}N
        ;
        DUPLENCOMP #1= ITE "Erase node?" "Erase nodes?"
        FLASHPTR RestoreHARDBUFF
        GRWConfirm ITE ::
          ( compute list of remaining nodes )
          OVER GRNodeList SWAP 1LAMBIND
          ' ::
            5GETLAM matchob? DROP
          ; ListMap
          ABND
          ( compute new item number )
          DUP LAM item #1+ UNCOERCE ' %= POSCOMP DUP #0<> IT #1-
          ' LAM item STO
          ( update graph )
          GRSub
          ( reset selection )
          NULL{} ' LAM sel STO
          ( recreate menu entries )
          DUP ' GRWNodeStr ListMap2 ' LAM list STO
          TRUE ' LAM ed? STO
        ;
        DROP
        FALSE
      ;
      FOUR #=casedrop ::
        ( order nodes )
        LAM sel NULLCOMP? caseFALSE
        ( construct the list of all nodes with selection in front )
        DUP GRNodeList LAM sel 1LAMBIND
        ' ::
          5GETLAM matchob? DROP
        ; ListMap
        1GETABND SWAP &COMP
        ( compute new item number )
        DUP LAM item #1+ UNCOERCE ' %= POSCOMP DUP #0<> IT #1-
        ' LAM item STO
        ( reorder nodes )
        GRSub
        ( reset selection )
        NULL{} ' LAM sel STO
        ( recreate menu entries )
        DUP ' GRWNodeStr ListMap2 ' LAM list STO
        TRUE ' LAM ed? STO
        FALSE
      ;
      FIVE #=casedrop ::
        ( selection toggle )
        LAM sel LAM item #1+ UNCOERCE ' %= POSCOMP
        DUP #0<> ITE ::
          LAM sel SWAP ListSplitAt CDRCOMP DUP UNROT &COMP ' LAM sel STO
          ' GRWUpdateNodeStr ListDo
          LAM item #1+ UNCOERCE GRWUpdateNodeStr
        ;
        ::
          DROP LAM sel LAM item #1+ UNCOERCE >TCOMP ' LAM sel STO
          LAM item #1+ UNCOERCE GRWUpdateNodeStr
        ;
        LAM item #1+ DUP LAM list LENCOMP #< ITE ::
          ' LAM item STO
        ;
        DROP
        FALSE
      ;
      SIX #=casedrop ::
        ( edge browser )
        FLASHPTR RestoreHARDBUFF
        LAM item #1+ UNCOERCE GRWEdgeBrowser
        COERCE OVER ?SKIP #1- ' LAM item STO
        SWAPDUP LAM ed? OR ' LAM ed? STO
        SWAP ITE ::
          DROP TRUE
        ;
        ::
          IT ::
            ( recreate menu entries )
            DUP ' GRWNodeStr ListMap2 ' LAM list STO
          ;
          FLASHPTR RestoreHARDBUFF
          FALSE
        ;
      ;
      SEVEN #=casedrop ::
	( HIST )
	DEPTH #1 #> NOTcase :: ERRBEEP FALSE ;
	1LAMBIND
	FLASHPTR History ClrDA1IsStat
	EditLExists? IT DEL_CMD
	FLASHPTR RestoreHARDBUFF
	1GETABND
	FALSE
      ;
      EIGHT #=casedrop ::
	( STO )
	DUP LAM item #1+ NTHCOMPDROP SWAP
	FALSE
      ;
      ERRBEEP DROPFALSE
    ;
  UNTIL
  LAM item
  LAM sel
  LAM ed?
  ABND
  !temp2
  select !temp1 !select
  temp2 edited? OR !edited?
  GRWGraphDisp
  DUP #0<> ITE ::
    ( move cursor to the given node )
    OVER NULLCOMP? case DROP ( graph is empty )
    UNCOERCE OVERSWAP GRGetNode GRNodePoint
    DUP GRWValid NOTcase DROP ( node is out of display range )
    temp2 ?SKIP GRWDrawCursor ( we have to redraw the cursor )
    GRWDispCoords CURSW #+ !y CURSW #+ !x
    temp2 ?SKIP GRWDrawCursor
    ( adjust window as necessary )
    x CURSW #- xwin #< IT :: x CURSW #- !xwin ;
    x CURSW #+ xwin 130 #+ #> IT :: x CURSW #+ 130 #- !xwin ;
    y CURSW #- ywin #< IT :: y CURSW #- !ywin ;
    y CURSW #+ ywin scrh-9 #+ #> IT :: y CURSW #+ scrh-9 #- !ywin ;
    ywin xwin WINDOWXY
  ;
  DROP
  temp2 ITE GRWRedraw ::
    ( compute the symmetric list difference of old and new selection;
      these are the nodes that need to be toggled )
    temp1 select 2DUP SWAP ListDiff UNROT ListDiff &COMP
    ( redraw the selection )
    GRWDrawSelect
  ;
  ZEROZERO !temp1 !temp2
;

NULLNAME GRWEdgeBrowser ( node -> ed? exit? node'|%0 )
::
  ( create menu entries )
  OVER OVER GRGetNode GRNodeEdges
  NULL{} { LAM sel } BIND
  ' GRWEdgeStr ListMap2
  ABND
  ( temporaries )
  %0 %0 ZEROZEROZERO ZERO FALSE NULL{} TRUE LAM simple? FALSE
  ver+? ITE :: SEVEN EIGHT ; :: FIVE SIX ;
  { LAM node LAM list LAM target LAM oldtarget LAM ofs LAM item LAM item2
    LAM action LAM ed? LAM sel LAM bidi? LAM simple? LAM quit?
    LAM boxh-1 LAM boxh } BIND
  BEGIN
    ZERO ' LAM action STO
    TRUE ' LAM bidi? STO
    ( show menu )
    ( make sure we have at least a dummy entry )
    LAM list DUPNULLCOMP? IT :: DROP "no entries" ONE{}N ;
    INNERCOMP
    "EDGES - NODE " LAM node COERCE #>$ &$ LAM item
    ( message handler )
    ::
      LAM simple? case ::
        ( restricted operation in coord mode )
        ' ::
	  THREE OVER#=case GRWBrowserEndInit
	  FOUR OVER#=case ::
	    ( key handler )
	    DROP
	    2DUP kpNoShift #= SWAP kcRightArrow #= AND
	    LAM list NULLCOMP? NOT ANDcase ::
	      2DROP ' :: TakeOver SIX GRWBrowserAction ;
	      TrueTrue
	    ;
	    2DUP kpNoShift #= SWAP kcLeftArrow #= ANDcase ::
	      2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
	      TrueTrue
	    ;
	    2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	      2DROP ' :: TakeOver EIGHT GRWBrowserAction ;
	      TrueTrue
	    ;
	    2DUP kpNoShift #= SWAP kcSto #= AND
	    LAM list NULLCOMP? NOT ANDcase ::
	      2DROP ' :: TakeOver NINE GRWBrowserAction ;
	      TrueTrue
	    ;
	    FALSE
	  ;
          FIVE OVER#=case ::
            ( menu )
            DROP
            ' ::
              NoExitAction
              { NullMenuKey
                NullMenuKey
                NullMenuKey
                NullMenuKey
                { "CANCL" FLASHPTR Choose3CANCL }
                { "OK"    FLASHPTR Choose3OK }
              }
            ;
            TRUE
          ;
          DROPFALSE
        ;
      ;
      LAM list NULLCOMP? case ::
        ( only allow ADD if edge list is empty )
        ' ::
          FOUR OVER#=case ::
            ( key handler )
            DROP
            2DUP kpRightShift #= SWAP TWO #= ANDcase ::
              2DROP ' :: TakeOver FALSE ' LAM bidi? STO TWO GRWBrowserAction ;
              TrueTrue
            ;
            2DUP kpNoShift #= SWAP kcLeftArrow #= ANDcase ::
              2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
              TrueTrue
            ;
	    2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	      2DROP ' :: TakeOver EIGHT GRWBrowserAction ;
	      TrueTrue
	    ;
            FALSE
          ;
          FIVE OVER#=case ::
            ( menu )
            DROP
            ' ::
              NoExitAction
              { NullMenuKey
                { "ADD"   :: TakeOver TWO GRWBrowserAction ; }
                NullMenuKey
                NullMenuKey
                { "CANCL" FLASHPTR Choose3CANCL }
                { "OK"    FLASHPTR Choose3OK }
              }
            ;
            TRUE
          ;
          DROPFALSE
        ;
      ;
      ' ::
        THREE OVER#=case GRWBrowserEndInit
        FOUR OVER#=case ::
          ( key handler )
          DROP
          2DUP kpNoShift #= SWAP kcChs #= ANDcase ::
            2DROP ' :: TakeOver FIVE GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpRightShift #= SWAP ONE #= ANDcase ::
            2DROP ' :: TakeOver FALSE ' LAM bidi? STO ONE GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpRightShift #= SWAP TWO #= ANDcase ::
            2DROP ' :: TakeOver FALSE ' LAM bidi? STO TWO GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpRightShift #= SWAP THREE #= ANDcase ::
            2DROP ' :: TakeOver FALSE ' LAM bidi? STO THREE GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpNoShift #= SWAP kcRightArrow #= ANDcase ::
            2DROP ' :: TakeOver SIX GRWBrowserAction ;
            TrueTrue
          ;
          2DUP kpNoShift #= SWAP kcLeftArrow #= ANDcase ::
            2DROP ' :: TakeOver SEVEN GRWBrowserAction ;
            TrueTrue
          ;
	  2DUP kpNoShift #= SWAP kcHist #= ANDcase ::
	    2DROP ' :: TakeOver EIGHT GRWBrowserAction ;
	    TrueTrue
	  ;
          2DUP kpNoShift #= SWAP kcSto #= ANDcase ::
	    2DROP ' :: TakeOver NINE GRWBrowserAction ;
            TrueTrue
          ;
          FALSE
        ;
        FIVE OVER#=case ::
          ( menu )
          DROP
          ' ::
            NoExitAction
            { { "EDIT"  :: TakeOver ONE GRWBrowserAction ; }
              { "ADD"   :: TakeOver TWO GRWBrowserAction ; }
              { "DEL"   :: TakeOver THREE GRWBrowserAction ; }
              { "ORDER" :: TakeOver FOUR GRWBrowserAction ; }
              { "CANCL" FLASHPTR Choose3CANCL }
              { "OK"    FLASHPTR Choose3OK }
            }
          ;
          TRUE
        ;
        DROPFALSE
      ;
    ;
    FLASHPTR Choose3
    ( process action )
    ITE ::
      LAM list SWAP EQUALPOSCOMP ' LAM item STO
      TRUE ' LAM quit? STO
      TRUE
    ;
    ::
      LAM action
      ZERO #=casedrop ::
        ZERO ' LAM item STO
        TRUE ' LAM quit? STO
        TRUE
      ;
      ONE #=casedrop ::
        ( edit the current edge )
        DUP LAM node GRGetNode GRSplitNode
        DUP LAM item #1+ NTHCOMPDROP
        ( graph point labels edges edge )
        LAM bidi? IT ::
          DUP GREdgeTarget LAM node %= ITE ZERO ::
            ( locate reverse edge )
            DUP GRSplitEdge LAM node SWAP GRMakeEdge
            ( graph point labels edges edge target redge )
            OVER ' LAM oldtarget STO
            7PICK ROT GRGetNode GRNodeEdges
            ( graph point labels edges edge redge redges )
            SWAP EQUALPOSCOMP
            DUP #0= IT :: FALSE ' LAM bidi? STO ;
          ;
          ' LAM item2 STO
        ;
        ( graph point labels edges edge )
        ( invoke the edge editor )
        4UNROLL { NULLLAM NULLLAM NULLLAM } BIND
        GRWEdgeEdit
        ITE ::
          3GETLAM 2GETLAM 1GETABND
          ( graph edge point labels edges )
          ( update the out-edge )
          4PICK LAM item #1+ ROT PUTLIST GRMakeNode
          ( graph edge node-info' )
          ROT LAM node ROT GRSetNode SWAP
          ( graph' edge )
          ( update the menu entry )
          LAM item #1+ OVER GRWEdgeStr
          LAM item #1+ LAM list PUTLIST ' LAM list STO
          ( graph' edge )
          TRUE ' LAM ed? STO
          LAM bidi? NOTcase DROP ( directed edge; we're done )
          ( bidirected edge; update reversal as well )
          GRSplitEdge SWAP ' LAM target STO LAM node SWAP GRMakeEdge
          ( graph' redge )
          LAM item2 #0<> ITE ::
            OVER LAM oldtarget GRGetNode GRSplitNode
            ( graph' redge rpoint rlabels redges )
            LAM target LAM oldtarget %= ITE ::
              ( update old in-edge )
              4ROLL LAM item2 ROT PUTLIST GRMakeNode
              ( graph' rnode-info' )
              LAM target SWAP GRSetNode
              ( graph'' )
              FALSE
            ;
            ::
              ( delete old in-edge )
              LAM item2 ListSplitAt CDRCOMP &COMP GRMakeNode
              ( graph' redge rnode-info' )
              ROTSWAP
              ( redge graph' rnode-info' )
              LAM oldtarget SWAP GRSetNode SWAP
              ( graph'' redge )
              LAM node LAM target %= ITE DROPFALSE TRUE
            ;
          ;
	  ::
	    LAM node LAM target %= ITE DROPFALSE TRUE
	  ;
          IT ::
            ( if we come here, we still have to add a new in-edge )
            ( graph' redge )
            OVER LAM target GRGetNode GRSplitNode
            ( graph' redge rpoint rlabels redges )
            4ROLL >TCOMP GRMakeNode
            ( graph' rnode-info' )
            LAM target SWAP GRSetNode
            ( graph'' )
          ;
        ;
        ABND
        FALSE
        FLASHPTR RestoreHARDBUFF
      ;
      TWO #=casedrop ::
	( create a new edge )
	' xNOVAL NULL{} GRMakeEdge
        ( graph edge )
        ( invoke the edge editor )
        GRWEdgeAdd
        IT ::
          DUP GREdgeTarget LAM node %= IT :: FALSE ' LAM bidi? STO ;
          ( add the out-edge )
          OVER LAM node GRGetNode GRSplitNode
          ( graph edge point labels edges )
          4PICK >TCOMP GRMakeNode
          ( graph edge node-info' )
          ROT LAM node ROT GRSetNode
          ( edge graph' )
          ( add a new menu entry )
          LAM list LENCOMP #1+ 3PICK GRWEdgeStr
          LAM list SWAP >TCOMP ' LAM list STO
          LAM list LENCOMP #1- ' LAM item STO
          SWAP
          ( graph' edge )
          LAM bidi? ITE ::
            ( add the in-edge )
            GRSplitEdge SWAP ' LAM target STO LAM node SWAP GRMakeEdge
            ( graph' redge )
            OVER LAM target GRGetNode GRSplitNode
            ( graph' redge rpoint rlabels redges )
            4ROLL >TCOMP GRMakeNode
            ( graph' rnode-info' )
            LAM target SWAP GRSetNode
            ( graph'' )
          ;
          DROP
          TRUE ' LAM ed? STO
        ;
        FALSE
        FLASHPTR RestoreHARDBUFF
      ;
      THREE #=casedrop ::
        ( delete the selected edges )
        DUP LAM node GRGetNode GRSplitNode
        ( graph point labels edges )
        ( determine list of edges to be deleted )
        LAM sel DUPNULLCOMP? IT ::
          DROP LAM item #1+ ONE{}N
        ;
        ( graph point labels edges items )
        DUPLENCOMP #1= ITE "Erase edge?" "Erase edges?"
        FLASHPTR RestoreHARDBUFF
        GRWConfirm ITE ::
          ( compute list of remaining items )
          SWAP DUPLENCOMP 1LAMBIND
          toLEN_DO (DO)
            INDEX@
          LOOP
          1GETABND {}N
          ( ... items edges allitems )
          UNROT SWAPROT OVER 1LAMBIND
          ' ::
            5GETLAM matchob? DROP
          ; ListMap
          ABND
          ( graph point labels edges items items' )
          ( keep an extra copy of the remaining items )
          6UNROLL 6PICK
          ( items' graph point labels edges items items' )
          ( compute the remaining edges )
          3PICK 1LAMBIND
          ' ::
            5GETLAM SWAP NTHCOMPDROP
          ; ListMap
          ABND
          ( items' graph point labels edges items edges' )
          UNROTSWAP 6UNROLL 6UNROLL
          ( items' items edges graph point labels edges' )
          ( keep an extra copy of the remaining edges )
          6UNROLL 6PICK
          ( items' edges' items edges graph point labels edges' )
          ( update the graph )
          GRMakeNode LAM node SWAP GRSetNode UNROT
          ( items' edges' graph' items edges )
          LAM bidi? ITE ::
            ( compute the list of deleted edges )
            1LAMBIND
            ' ::
              5GETLAM SWAP NTHCOMPDROP
            ; ListMap
            ABND
            ( items' edges' graph' edges'' )
            ( delete the reversals )
            ' ::
              GRSplitEdge OVER LAM node %= case2DROP ( loop, already handled )
              ( construct the reverse edge )
              LAM node SWAP GRMakeEdge
              ( graph' target redge )
              ( look for it at the target node )
              3PICK 3PICK GRGetNode GRSplitNode
              ( graph' target redge rpoint rlabels redges )
              4ROLL OVERSWAP EQUALPOSCOMP
              ( graph' target rpoint rlabels redges #pos )
              DUP #0<> ITE ::
                ListSplitAt CDRCOMP &COMP
                ( graph' target rpoint rlabels redges' )
                GRMakeNode GRSetNode
              ;
              5DROP
            ; ListDo
          ;
          2DROP
          ( items' edges' graph' )
          ( compute new item number )
          ROT LAM item #1+ ' #= POSCOMP DUP #0<> IT #1-
          ' LAM item STO
          ( reset selection )
          NULL{} ' LAM sel STO
          ( recreate menu entries )
          SWAP ' GRWEdgeStr ListMap2 ' LAM list STO
          TRUE ' LAM ed? STO
        ;
        4DROP
        FALSE
      ;
      FOUR #=casedrop ::
        ( order edges )
        LAM sel NULLCOMP? caseFALSE
        DUP LAM node GRGetNode GRSplitNode
        ( graph point labels edges )
        ( construct the list of all edge indices with selection in front )
        DUPLENCOMP 1LAMBIND
        toLEN_DO (DO)
          INDEX@
        LOOP
        1GETABND {}N
        LAM sel 1LAMBIND
        ' ::
          5GETLAM matchob? DROP
        ; ListMap
        1GETABND SWAP &COMP
        ( graph point labels edges order )
        ( compute new item number )
        DUP LAM item #1+ ' #= POSCOMP DUP #0<> IT #1-
        ' LAM item STO
        ( graph point labels edges order )
        SWAP 1LAMBIND ' ::
          5GETLAM SWAP NTHCOMPDROP
        ; ListMap
        ABND
        ( graph point labels edges' )
        4UNROLL 4PICK
        ( edges' graph point labels edges' )
        ( update graph )
        GRMakeNode LAM node SWAP GRSetNode
        ( edges' graph' )
        ( reset selection )
        NULL{} ' LAM sel STO
        ( recreate menu entries )
        SWAP ' GRWEdgeStr ListMap2 ' LAM list STO
        TRUE ' LAM ed? STO
        FALSE
      ;
      FIVE #=casedrop ::
        ( selection toggle )
        DUP LAM node GRGetNode GRNodeEdges
        LAM sel LAM item #1+ ' #= POSCOMP
        DUP #0<> ITE ::
          LAM sel SWAP ListSplitAt CDRCOMP DUP UNROT &COMP ' LAM sel STO
          ' GRWUpdateEdgeStr ListDo
          LAM item #1+ GRWUpdateEdgeStr
        ;
        ::
          DROP LAM sel LAM item #1+ >TCOMP ' LAM sel STO
          LAM item #1+ GRWUpdateEdgeStr
        ;
        DROP
        LAM item #1+ DUP LAM list LENCOMP #< ITE ::
          ' LAM item STO
        ;
        DROP
        FALSE
      ;
      SIX #=casedrop ::
        ( go to target node )
        LAM item #1+ ' LAM item STO
        TRUE
      ;
      SEVEN #=casedrop ::
        ( go to source node )
        ZERO ' LAM item STO
        TRUE
      ;
      EIGHT #=casedrop ::
	( HIST )
	DEPTH #1 #> NOTcase :: ERRBEEP FALSE ;
	1LAMBIND
	FLASHPTR History ClrDA1IsStat
	EditLExists? IT DEL_CMD
	FLASHPTR RestoreHARDBUFF
	1GETABND
	FALSE
      ;
      NINE #=casedrop ::
	( STO )
        DUP LAM node GRGetNode GRNodeEdges
	LAM item #1+ NTHCOMPDROP SWAP
	FALSE
      ;
      ERRBEEP DROPFALSE
    ;
  UNTIL
  LAM ed?
  LAM quit?
  LAM item #0<> ITE ::
    3PICK LAM node GRGetNode GRNodeAdj LAM item NTHCOMPDROP
  ;
  ::
    LAM quit? ITE %0 ::
      LAM node
    ;
  ;
  ABND
;

NULLNAME GRWBrowserAction ( # -> )
::
  ' LAM action STO
  3GETLAM ' LAM ofs STO
  2GETLAM 3GETLAM #+ ' LAM item STO
  TRUE 1PUTLAM
;

NULLNAME GRWBrowserEndInit
::
  ( end init message handler )
  ( we use this to set the scroll value )
  LAM item LAM boxh #< case NOP
  LAM list LENCOMP LAM boxh #- DUP
  LAM ofs #< case ::
    3PUTLAM LAM item 3GETLAM #- 2PUTLAM
  ;
  DROP
  LAM ofs LAM item #> case ::
    LAM item 3PUTLAM ZERO 2PUTLAM
  ;
  LAM item LAM ofs #- LAM boxh-1 #> case ::
    LAM item LAM boxh-1 #- 3PUTLAM LAM boxh-1 2PUTLAM
  ;
  LAM ofs 3PUTLAM LAM item LAM ofs #- 2PUTLAM
;

NULLNAME GRWNodeStr ( node# node-info -> $ )
::
  SWAP DUP #>$ ":" &$ SWAP
  LAM sel SWAP UNCOERCE ' %= POSCOMP DUP #0<> ITE ::
    #>$ &$
  ;
  DROP
  APPEND_SPACE
  SWAP DUP GRNodeLabels SWAP GRNodeAdj &COMP DO>STR &$
;

NULLNAME GRWUpdateNodeStr
::
  ( node )
  DUP COERCE DUP ROT
  ( node# node# node )
  4PICK SWAP GRGetNode GRWNodeStr
  ( node# node$ )
  SWAP LAM list PUTLIST ' LAM list STO
;

NULLNAME GRWEdgeStr ( edge# edge-info -> $ )
::
  SWAP DUP #>$ ":" &$ SWAP
  LAM sel SWAP ' #= POSCOMP DUP #0<> ITE ::
    #>$ &$
  ;
  DROP
  APPEND_SPACE
  SWAP DO>STR &$
;

NULLNAME GRWUpdateEdgeStr
::
  ( edges edge# )
  2DUP NTHCOMPDROP OVERSWAP GRWEdgeStr
  ( edges edge# edge$ )
  SWAP LAM list PUTLIST ' LAM list STO
  ( edges )
;

**** end of node browser ****

NULLNAME GRWCursor
::
  ITE ::
    GRWCursorCoords SWAP
  ;
  GRWResetMode
;

NULLNAME GRWMove
::
  OVER mark GRGetNode GRNodePoint DUP GRWDrawMark SWAP
  ITE ::
    ( determine nodes to move )
    mark select matchob? ITE :: select ; ONE{}N
    ( compute delta )
    GRWCursorCoords ROT C%- ( stack now: graph nodelist delta )
    ( move selected nodes )
    1LAMBIND
    ' ::
      2DUP GRGetNode GRSplitNode ROT
      3GETLAM C%+ UNROT GRMakeNode
      GRSetNode
    ; ListDo
    ABND
    %0 !mark
    GRWRedraw
    TRUE !edited?
  ;
  ::
    DROP
    %0 !mark
  ;
  GRWResetMode
;

NULLNAME GRWDel
::
  ( determine list of nodes to be deleted )
  GRWFindNode ITE ::
    select matchob? ITE :: select ; ONE{}N
    TRUE
  ;
  ::
    select DUPNULLCOMP? ITE DROPFALSE TRUE
  ;
  ITE ::
    GRWTextDisp
    DUPLENCOMP #1= ITE "Erase node?" "Erase nodes?"
    GRWConfirm ITE ::
      ( compute list of remaining nodes )
      OVER GRNodeList SWAP 1LAMBIND
      ' ::
        5GETLAM matchob? DROP
      ; ListMap
      1GETABND select EQ IT ::
        ( reset selection )
        NULL{} !select
      ;
      ( update graph )
      GRSub
      GRWRedraw
      TRUE !edited?
    ;
    :: DROP GRWGraphDisp ;
  ;
  ERRBEEP
;

NULLNAME GRWClear
::
  GRWTextDisp "Erase graph?" GRWConfirm ITE ::
    DROP NULL{} NULL{} !select
    ZEROZERO !xwin !ywin
    CURSW CURSW !x !y
    GRWRedraw
    TRUE !edited?
  ;
  GRWGraphDisp
;

NULLNAME GRWCancel
::
  coord? ITE ::
    FALSE
    callb DUPTYPELIST? IT CARCOMP
    EVAL
  ;
  ::
    edited? ITE :: GRWTextDisp "Discard edits?" GRWConfirm ; TRUE
    ITE :: TRUE !exit? DROP FALSE ; GRWGraphDisp
  ;
;

NULLNAME GRWEnter
::
  coord? ITE ::
    TRUE
    callb DUPTYPELIST? IT CARCOMP
    EVAL
  ;
  ::
    TRUE !exit? TRUE
  ;
;

NULLNAME GRWRSEnter
::
  coord? ITE ::
    callb DUPTYPELIST? ITE ::
      #2 NTHCOMPDROP TRUE SWAP EVAL
    ;
    :: DROP ERRBEEP ;
  ;
  ERRBEEP
;

NULLNAME GRWLSEnter
::
  coord? ITE ::
    callb DUPTYPELIST? ITE ::
      #3 NTHCOMPDROP TRUE SWAP EVAL
    ;
    :: DROP ERRBEEP ;
  ;
  ERRBEEP
;

NULLNAME GRWToggleSelect
::
  select OVER ' %= POSCOMP
  DUP #0<> ITE ::
    select SWAP ListSplitAt CDRCOMP &COMP !select
    DROPFALSE
  ;
  ::
    DROP select SWAP >TCOMP !select
    TRUE
  ;
;

NULLNAME GRWDrawSelect
::
  DUPNULLCOMP? caseDROP
  >R 'R
  [BEGIN]
    OVERSWAP GRGetNode GRNodePoint GRWDrawSel
    RSWAP ticR
  [WHILE]
    RSWAP
  [REPEAT]
;

NULLNAME GRWSelectToggle
::
  GRWFindNode ITE ::
    DUP GRWToggleSelect DROP
    OVERSWAP GRGetNode GRNodePoint GRWDrawSel
  ;
  ::
    ( deselect all nodes )
    select GRWDrawSelect
    NULL{} !select
  ;
;

NULLNAME GRWStoSelect
::
  select SWAP
;

NULLNAME GRWRclSelect
::
  DEPTH #1 #> ITE ::
    OVER OVER LENCOMP UNCOERCE SWAP GRParseNodeList ITE ::
      select GRWDrawSelect
      SWAP
      OVER LENCOMP UNCOERCE 1LAMBIND
      ' ::
        DUP %0 %<= caseDROP
        DUP 5GETLAM %> caseDROP
      ; ListMap
      ABND
      DUP !select
      GRWDrawSelect
    ;
    ERRBEEP
  ;
  ERRBEEP
;

NULLNAME GRWSto
::
  select NULLCOMP? ITE DUP ::
    DUP select GRSub
  ;
  SWAP
;

NULLNAME GRWRcl
::
  DEPTH #1 #> ITE ::
    OVER TYPELIST? NOTcase ERRBEEP
    OVER NULLCOMP? case SWAPDROP
    OVER GRParseGraph ITE ::
      ( clear current selection )
      select GRWDrawSelect
      ( set new selection )
      OVER GRNodeList
      OVER LENCOMP UNCOERCE 1LAMBIND
      ' ::
        5GETLAM %+
      ; ListMap
      ABND
      !select
      ( determine cursor coordinates )
      SWAP GRWCursorCoords
      ( keep a copy of the coordinates for later use )
      UNROT 3PICK
      ( embed nodes if necessary )
      C%>% ( xmin ymax )
      xmax NODEW DUP #+ #- UNCOERCE wxr %* wxmin %+
      wymin ( xmin ymax xmax ymin )
      ROT ( xmin xmax ymin ymax )
      GREmbed
      ROT 3PICK LENCOMP UNCOERCE SWAP
      %MAXREAL %-MAXREAL
      ' NULLLAM FOUR NDUPN DOBIND ( %nodes0 delta xofs yofs )
      ( compute coordinate offsets )
      DUP ' ::
        GRNodePoint C%>%
        DUP 3GETLAM %> ITE 3PUTLAM DROP
        DUP 4GETLAM %< ITE 4PUTLAM DROP
      ; ListDo
      ( compute delta )
      3GETLAM 2GETLAM 1GETLAM %>C% C%- 3PUTLAM
      ( update new subgraph )
      ' ::
        GRSplitNode
        ROT 7GETLAM C%+ UNROT
        ' ::
          GRSplitEdge
          SWAP 12GETLAM %+ SWAP
          GRMakeEdge
        ; ListMap
        GRMakeNode
      ; ListMap
      4GETLAM
      ABND
      UNROT DUPUNROT &COMP
      ( draw new subgraph )
      GRWDrawCursor
      UNROT
      ( graph' %nodes0 subgraph )
      ( build the necessary temp tables for the drawing routine )
      OVER COERCE
      ( ... subgraph #nodes0 )
      %0 OVER NDUPN {}N
      3PICK ' GRNodePoint ListMap &COMP !temp2
      NULL{} OVER NDUPN {}N
      3PICK ' GRNodeAdj ListMap &COMP !temp3
      NULL{} OVER NDUPN {}N
      3PICK ' :: GRNodeEdges ' :: GREdgeLabels CARCOMP ; ListMap ; ListMap
      &COMP !temp4
      FALSE SWAP 3PICK LENCOMP #+ NDUPN {}N !temp5
      >R 'R
      [BEGIN]
        SWAP %1+ SWAP
        GRWDrawNodeWithEdges
        RSWAP ticR
      [WHILE]
        RSWAP
      [REPEAT]
      DROP
      ZEROZEROZERO !temp2 !temp3 !temp4
      ZEROZERO !temp5 !temp6
      ( draw new selection )
      select GRWDrawSelect
      GRWDrawCursor
      TRUE !edited?
    ;
    ERRBEEP
  ;
  ERRBEEP
;

NULLNAME GRWHist
::
  DEPTH #1 #> NOTcase ERRBEEP
  GRWTextDisp 1LAMBIND
  FLASHPTR History ClrDA1IsStat
  EditLExists? IT DEL_CMD
  1GETABND GRWGraphDisp
;
                              
* dialogs ********************************************************************

* setup dialog

NULLNAME GRWSetup ( -> )
::
  GRWTextDisp
  prompt? welbl? wnlbl? wnum? wz wyr wymax wymin wxr wxmax wxmin
  ' NULLLAM TWELVE NDUPN DOBIND
  DoGRW_SETUPInform
  ClrDA1IsStat
  ITE ::
    12GETLAM TWELVE UNROLL ABND
    !prompt? !wnlbl? !welbl? !wnum? !wz !wyr !wymax !wymin !wxr !wxmax !wxmin
    GRWParCheck
    ( update the user's GRWPAR variable )
    GRWSavePar
    ( reinitialize the display )
    ZEROZERO !xwin !ywin
    CURSW CURSW !x !y
    GRWSetSize
    GRWResize
  ;
  ::
    12GETLAM ABND
    GRWGraphDisp
  ;
;

* node editor

NULLNAME GRWNodeAdd ( node-info -> node-info' T | F )
::
  GRSplitNode SWAPROT
  ( edges labels point )
  ' NULLLAM FOUR NDUPN DOBIND
  DoADD_NODEInform
  ClrDA1IsStat
  ITE ::
    DUPTYPELIST? ?SKIP ::
      DUPTYPETAG? ?SKIP ::
        NULL$ >TAG
      ;
      ONE{}N
    ;
    3GETLAM GRMakeNode 4GETLAM ABND SWAP
    TRUE
  ;
  ::
    4GETLAM ABND
    FALSE
  ;
;

NULLNAME GRWNodeEdit ( node-info -> node-info' T | F )
::
  GRSplitNode SWAPROT
  ( edges labels point )
  ' NULLLAM FOUR NDUPN DOBIND
  DoEDIT_NODEInform
  ClrDA1IsStat
  ITE ::
    DUPTYPELIST? ?SKIP ::
      DUPTYPETAG? ?SKIP ::
        NULL$ >TAG
      ;
      ONE{}N
    ;
    3GETLAM GRMakeNode 4GETLAM ABND SWAP
    TRUE
  ;
  ::
    4GETLAM ABND
    FALSE
  ;
;

* edge editor

NULLNAME GRWEdgeAdd ( edge-info -> edge-info' T | F )
::
  OVER LENCOMP SWAP GRSplitEdge SWAP
  { NULLLAM LAM n NULLLAM NULLLAM } BIND
  DoADD_EDGEInform
  ClrDA1IsStat
  ITE ::
    DUPTYPELIST? ?SKIP ::
      DUPTYPETAG? ?SKIP ::
        NULL$ >TAG
      ;
      ONE{}N
    ;
    GRMakeEdge 4GETLAM ABND SWAP
    TRUE
  ;
  ::
    4GETLAM ABND
    FALSE
  ;
;

NULLNAME GRWEdgeEdit ( edge-info -> edge-info' T | F )
::
  OVER LENCOMP SWAP GRSplitEdge SWAP
  { NULLLAM LAM n NULLLAM NULLLAM } BIND
  DoEDIT_EDGEInform
  ClrDA1IsStat
  ITE ::
    DUPTYPELIST? ?SKIP ::
      DUPTYPETAG? ?SKIP ::
        NULL$ >TAG
      ;
      ONE{}N
    ;
    GRMakeEdge 4GETLAM ABND SWAP
    TRUE
  ;
  ::
    4GETLAM ABND
    FALSE
  ;
;

* Inform msg handlers

DEFINE IfMsgOKKey SIXTEEN
DEFINE IfMsgGetMenu ELEVEN

NULLNAME SetupIfHandler
::
  IfMsgGetMenu #=casedrop ::
    ( forbid CALC, it's dangerous since we can mess with the graphics disp )
    DUP INNERCOMP 6ROLL DROP ' NullMenuKey 5UNROLL {}N TRUE
  ;
  DROPFALSE
;

NULLNAME NodeIfHandler
::
  IfMsgGetMenu #=casedrop ::
    DUP INNERCOMP 6ROLL DROP ' NullMenuKey 5UNROLL {}N TRUE
  ;
  IfMsgOKKey #=casedrop ::
    ( validate label list )
    ::
      ONE FLASHPTR IfGetFieldValue
      DUPTYPELIST? NOT casedrop TRUE
      GRParseLabels NOTcase ::
        "Bad label value (must be tagged)" FlashWarning
        ONE FLASHPTR IfSetField
        FALSE
      ;
      TRUE
    ;
    TRUE
  ;
  DROPFALSE
;

NULLNAME EdgeIfHandler
::
  IfMsgGetMenu #=casedrop ::
    DUP INNERCOMP 6ROLL DROP ' NullMenuKey 5UNROLL {}N TRUE
  ;
  IfMsgOKKey #=casedrop ::
    ::
      ( validate target node number and label list )
      ZERO FLASHPTR IfGetFieldValue DUP %FP %0<> case ::
        DROP
        "Bad node number (must be integer)" FlashWarning
        ZERO FLASHPTR IfSetField
        FALSE
      ;
      DUP %0 %<= SWAP LAM n UNCOERCE %> ORcase ::
        "Bad node number (out of range)" FlashWarning
        ZERO FLASHPTR IfSetField
        FALSE
      ;
      ONE FLASHPTR IfGetFieldValue
      DUPTYPELIST? NOT casedrop TRUE
      GRParseLabels NOTcase ::
        "Bad label value (must be tagged)" FlashWarning
        ONE FLASHPTR IfSetField
        FALSE
      ;
      TRUE
    ;
    TRUE
  ;
  DROPFALSE
;

* yes/no confirmation

NULLNAME GRWConfirm ( $ -> T | F )
::
  { { "YES" TRUE } { "NO" FALSE } }
  ROMPTR 0B3 063 ( ~ChooseSimple )
  ?SKIP FALSE
;
		 
* check and correct display parameters

NULLNAME GRWParCheck ( -> )
::
  ( swap range boundaries if necessary )
  wxmin wxmax 2DUP %< ITE 2DROP :: !wxmin !wxmax ;
  wymin wymax 2DUP %< ITE 2DROP :: !wymin !wymax ;
  ( check x resolution - assume default if zero or too small )
  wxr %ABS !wxr wxmax wxmin %= ITE
  :: wxr %0= IT :: % 1e-2 !wxr ; ;
  :: wxmax wxmin %- MAXDIM UNCOERCE %/ wxr OVER %< ITE !wxr DROP ;
  ( same for y resolution )
  wyr %ABS !wyr wymax wymin %= ITE
  :: wyr %0= IT :: % 1e-2 !wyr ; ;
  :: wymax wymin %- MAXDIM UNCOERCE %/ wyr OVER %< ITE !wyr DROP ;
  ( extend range if it is empty )
  wxmin wxmax %= IT :: wxmin % 126 wxr %* %+ !wxmax ;
  wymin wymax %= IT :: wymin scrh-13 UNCOERCE wyr %* %+ !wymax ;
*  ( extend x-range s.t. it covers at least one screenful )
*  wxmax wxmin %- wxr %/ %CEIL % 126 %<
*  IT :: wxmin % 126 wxr %* %+ !wxmax ;
*  ( same for y-range )
*  wymax wymin %- wyr %/ %CEIL scrh-13 UNCOERCE %<
*  IT :: wymin scrh-13 UNCOERCE wyr %* %+ !wymax ;
  ( check zoom value - set to default if zero )
  wz %ABS DUP%0= IT :: DROP %2 ; !wz
  ( set coordinate display precision )
  wxmax wxmin %- %8 Prec !xprec
  wymax wymin %- %8 Prec !yprec
;

* load display setup from GRWPAR variable

NULLNAME GRWLoadPar
::
  ' ID GRWPAR @ ITE ::
    ( use GRWPAR values )
    DUPLENCOMP ELEVEN #<> case DROPFALSE
    DUP ' TYPEREAL? ListDoWhile NOTcase DROPFALSE
    INNERCOMP DROP
    FOUR {}N ' %0<> ListDo
    TRUE
  ;
  FALSE
  ?SKIP ::
    ( provide reasonable defaults )
    %0 %1 %0 %1                         ( user coordinates )
    % 1e-2 % 1e-2                       ( display resolution )
    %2                                  ( zoom factor )
    TRUE                                ( node numbers? )
    TRUE                                ( node labels? )
    TRUE                                ( edge labels?  )
    FALSE                               ( prompt mode )
  ;
  !prompt? !welbl? !wnlbl? !wnum? !wz !wyr !wxr !wymax !wymin !wxmax !wxmin
;

* save display setup in GRWPAR variable

NULLNAME GRWSavePar
::
  wxmin wxmax wymin wymax wxr wyr wz
  wnum? ITE %1 %0
  wnlbl? ITE %1 %0
  welbl? ITE %1 %0
  prompt? ITE %1 %0
  ELEVEN {}N ' ID GRWPAR STO
;

* help browser ***************************************************************

NULLNAME GRWHelpPages
{
  "\13\03\13GraphWriter Help              1/8\13\03\13"
  "                     KEY COMMANDS"
  "VAR      toggle label display"
  "STO RCL  subgraph \8E\8D stack"
  "HIST     visit stack"
  "\8E\90\8F\8D     cursor movement"
  "+/-      toggle select"
  "+ - \D7    zoom (RS: fullscreen)"
  "LS \D7     redraw screen"
  
  "\13\03\13GraphWriter Help              2/8\13\03\13"
  "                     KEY COMMANDS"
  "ENTER    accept changes and exit"
  "CANCEL   abandon changes and exit"
  "                        SHORTCUTS"
  "MODE     \8D \13\04\13SETUP\13\04\13 menu command"
  "CAT      \8D \13\04\13 CAT \13\04\13 menu command"
  "DEL      \8D \13\04\13 DEL \13\04\13 menu command"
  "CLEAR    \8D \13\04\13CLEAR\13\04\13 menu command"

  "\13\03\13GraphWriter Help              3/8\13\03\13"
  "                    MENU COMMANDS"
  "\13\04\13 NODE\13\04\13 create nodes"
  "  ENTER : create node at cursor"
  "  CANCEL: exit NODE mode"
  "\13\04\13 EDGE\13\04\13 create edges (RS: path)"
  "  ENTER : edge to node at cursor"
  "    RS: forward, LS: backward"
  "  CANCEL: exit EDGE/PATH mode"

  "\13\03\13GraphWriter Help              4/8\13\03\13"
  "                    MENU COMMANDS"
  "\13\04\13 CAT \13\04\13 node/edge browser"
  "\13\04\13(X,Y)\13\04\13 view cursor coordinates"
  "  ENTER : point \8D stack"
  "  CANCEL: exit CURSOR mode"
  "\13\04\13 MOVE\13\04\13 move node/selection"
  "  ENTER : finish move"
  "  CANCEL: cancel move"
  
  "\13\03\13GraphWriter Help              5/8\13\03\13"
  "                    MENU COMMANDS"
  "\13\04\13 DEL \13\04\13 delete node/selection"
  "\13\04\13CLEAR\13\04\13 delete entire graph"
  "\13\04\13SETUP\13\04\13 configure GRW"
  "\13\04\13GROB\8D\13\04\13 PICT \8D stack"
  "\13\04\13NODE\8D\13\04\13 node# \8D stack"
  "\13\04\13MARK\8D\13\04\13 selection \8D stack"
  "\13\04\13\8DMARK\13\04\13 stack \8D selection"
  
  "\13\03\13GraphWriter Help              6/8\13\03\13"
  "                 BROWSER COMMANDS"
  "\13\04\13 EDIT\13\04\13 edit current node/edge"
  "\13\04\13 ADD \13\04\13 add a new node/edge"
  "\13\04\13 DEL \13\04\13 delete current node/edge"
  "\13\04\13ORDER\13\04\13 reorder nodes/edges"
  ""
  "RS: edit/add/del out-edge only"
  ""

  "\13\03\13GraphWriter Help              7/8\13\03\13"
  "                 BROWSER COMMANDS"
  "CANCEL exit"
  "ENTER  place cursor on this node"
  "\8D      show edges/target node"
  "\8E      back to source node"
  "+/-    toggle select"
  "STO    current node/edge \8D stack"
  "HIST   visit stack"
  
  "\13\03\13GraphWriter Help              8/8\13\03\13"
  "                            ABOUT"
  "GraphWriter Version 3.1"
  "Graph editor for the HP 49 series"
  ""
  "Copyright (c) 2001-2015"
  "by Albert Grf"
  ""
  "License: GNU Public License V2"
}

NULLNAME GRWHelpPage
::
  DOCLLCD ZEROZERO
  GRWHelpPages LAM top DUP EIGHT #+ SUBCOMP
  DUP CARCOMP SWAP CDRCOMP ' :: SWAP NEWLINE$&$ SWAP &$ ; ListDo
  $>grobCR XYGROBDISP
;

NULLNAME GRWHelpPrevPage
::
  LAM top NINE 2DUP #> ITE #-
  ::
    2DROP GRWHelpPages LENCOMP #1- NINE #/ SWAPDROP NINE #* #1+
  ;
  ' LAM top STO GRWHelpPage
;

NULLNAME GRWHelpNextPage
::
  LAM top NINE #+ DUP GRWHelpPages LENCOMP #> IT DROPONE
  ' LAM top STO GRWHelpPage
;
	    
NULLNAME GRWHelp
::
  GRWTextDisp
  RECLAIMDISP ClrDA1IsStat
  hlptop FALSE { LAM top LAM quit? } BIND
  GRWHelpPage
  ' DispMenu.1
  ' ::
    kpNoShift #=casedrop ::
      DUP#<7 casedrpfls
      kcLeftArrow ?CaseKeyDef :: GRWHelpPrevPage ;
      kcRightArrow ?CaseKeyDef :: GRWHelpNextPage ;
      kcOn ?CaseKeyDef :: TRUE ' LAM quit? STO ;
      kcEnter ?CaseKeyDef :: TRUE ' LAM quit? STO ;
      kcRightShift #=casedrpfls
      kcLeftShift #=casedrpfls
      DROP 'DoBadKeyT
    ;
    kpLeftShift #=casedrop ::
      DUP#<7 casedrpfls
      kcRightShift #=casedrpfls
      kcLeftShift #=casedrpfls
      DROP 'DoBadKeyT
    ;
    kpRightShift #=casedrop ::
      DUP#<7 casedrpfls
      kcRightShift #=casedrpfls
      kcLeftShift #=casedrpfls
      DROP 'DoBadKeyT
    ;
    2DROP 'DoBadKeyT
  ;
  TrueTrue
  { "\1C" GRWHelpPrevPage }
  { "\86" GRWHelpNextPage }
  ' NullMenuKey
  ' NullMenuKey
  ' NullMenuKey
  { "OK" :: TRUE ' LAM quit? STO ; }
  SIX {}N
  ONEFALSE
  ' LAM quit?
  ' ERRJMP
  ParOuterLoop
  LAM top
  ABND
  !hlptop
  RECLAIMDISP ClrDA1IsStat
  GRWGraphDisp
;

* editor *********************************************************************

* menu display

NULLNAME GRWMenuDisp ( -> )
::
  coord? ITE
  ::
    EIGHT 131 MAKEGROB
    mode $>grob ZERO TWO Repl
    "X:" x CURSW #- UNCOERCE wxr %* wxmin %+ xprec Round a%>$
    &$ $>grob #16 TWO Repl
    "Y:" ymax y #- CURSW #- UNCOERCE wyr %* wymin %+ yprec Round a%>$
    &$ $>grob #4C TWO Repl
    HARDBUFF2 ZEROZERO GROB!
  ;
  DispMenu.1
;

* set/reset edit mode

NULLNAME GRWSetMode ( $ callb -> )
::
  !callb !mode TRUE !coord?
;

NULLNAME GRWResetMode ( -> )
::
  ' DROP !callb NULL$ !mode FALSE !coord?
;

* main editor routine

NULLNAME GRWEditor ( graph -> graph' T | F )
::

  POLSaveUI                             ( start POL )
  ERRSET ::
  
    ( initialize local variables )

    ( calculator type; just check the screen height )
    DOLCD> GROBDIM DROP #40 #>
    
    ( vertical screen dimensions )
    DUP ITE :: 67 71 72 ; :: 51 55 56 ;

    ( misc temp values )
    ZEROZEROZERO
    ZEROZEROZERO
    
    ( auxiliary data structures )
    ONE					  ( top value for help browser )
    %2 %2                                 ( coord display precision )
    90 TestSysFlag			  ( fnt flag )
    FALSE                                 ( prompt mode )
    NULL{}                                ( list of selected nodes )
    ' DROP                                ( callback )
    %0                                    ( marked node )

    ( mode info )
    FALSE                                 ( exit? )
    FALSE                                 ( edited? )
    FALSE                                 ( path mode? )
    FALSE                                 ( coordinate view? )

    NULL$                                 ( edit mode indicator )

    ( setup )
    TRUE                                  ( edge labels? )
    TRUE                                  ( node labels? )
    TRUE                                  ( node numbers? )
    %2                                    ( zoom factor )
    % 1e-2 % 1e-2                         ( display resolution )
    %1 %0 %1 %0                           ( user coordinates )

    ( screen setup )
    ZEROZERO                              ( initial window offset )
    ZEROZERO                              ( screen dimensions )
    CURSW CURSW                           ( cursor position )

    ' NULLLAM THIRTYNINE NDUPN DOBIND

    ( load and check display parameters )
    GRWLoadPar
    GRWParCheck

    ( embed graph nodes if necessary )
    wxmin wxmax wymin wymax GREmbed

    ( initialize display )
    90 SetSysFlag
    GRWInitDisp

    ( POL )

    ' GRWMenuDisp                         ( display action )

    ' ::                                  ( hard key handler )
      kpNoShift #=casedrop ::
        ( pass on softkeys -- ignored in coord? mode )
        DUP#<7 casedrop :: coord? ITE :: ' NOP TRUE ; FALSE ;
        ( cursor keys )
        kcUpArrow ?CaseKeyDef :: GRWCursorUp ;
        kcLeftArrow ?CaseKeyDef :: GRWCursorLeft ;
        kcDownArrow ?CaseKeyDef :: GRWCursorDown ;
        kcRightArrow ?CaseKeyDef :: GRWCursorRight ;
        ( MODE key )
	kcMode ?CaseKeyDef :: coord? ITE ERRBEEP GRWSetup ;
	( VAR key )
	kcVar ?CaseKeyDef :: wnlbl? welbl? OR ITE ::
	                       FalseFalse !wnlbl? !welbl?
			     ;
			     ::
			       TrueTrue !wnlbl? !welbl?
			     ;
			     GRWRedraw ;
        ( STO key )
        kcSto ?CaseKeyDef :: coord? ITE ERRBEEP GRWSto ;
        ( HIST key )
        kcHist ?CaseKeyDef :: GRWHist ;
        ( CAT key, 49G only )
        kcCat ?CaseKeyDef :: ver+? ITE ERRBEEP GRWBrowser ;
        ( zoom keys )
        kcPlus ?CaseKeyDef :: GRWZoomIn ;
        kcMinus ?CaseKeyDef :: GRWZoomOut ;
        kcTimes ?CaseKeyDef :: GRWZoomRevert ;
        ( selection )
        kcChs ?CaseKeyDef :: coord? ITE ERRBEEP GRWSelectToggle ;
        ( CANCEL and ENTER )
        kcOn ?CaseKeyDef :: GRWCancel ;
        kcEnter ?CaseKeyDef :: GRWEnter ;
        ( ignore shift keys )
        kcRightShift #=casedrpfls
        kcLeftShift #=casedrpfls
        ( handle NEXT key - ignored if in coord? mode )
        kcNxt #=casedrop :: coord? ITE :: ' NOP TRUE ; FALSE ;
        ( handle errors )
        DROP 'DoBadKeyT
      ;
      kpRightShift #=casedrop ::
        DUP#<7 casedrop :: coord? ITE :: ' NOP TRUE ; FALSE ;
        ( cursor keys )
        kcUpArrow ?CaseKeyDef :: GRWCursorDTop ;
        kcLeftArrow ?CaseKeyDef :: GRWCursorDBegin ;
        kcDownArrow ?CaseKeyDef :: GRWCursorDBottom ;
        kcRightArrow ?CaseKeyDef :: GRWCursorDEnd ;
        ( CLEAR key )
        kcBack ?CaseKeyDef :: coord? ITE ERRBEEP GRWClear ;
        ( CAT key, 49G+ and later )
        kcSymb ?CaseKeyDef :: ver+? ITE GRWBrowser ERRBEEP ;
        ( zoom keys )
        kcPlus ?CaseKeyDef :: GRWFullSqrMax ;
        kcMinus ?CaseKeyDef :: GRWFullSqrMin ;
        kcTimes ?CaseKeyDef :: GRWFullScreen ;
        ( CANCEL and ENTER )
        kcOn ?CaseKeyDef :: TurnOff ;
        kcEnter ?CaseKeyDef :: GRWRSEnter ;
        kcRightShift #=casedrpfls
        kcLeftShift #=casedrpfls
        DROP 'DoBadKeyT
      ;
      kpLeftShift #=casedrop ::
        DUP#<7 casedrop :: coord? ITE :: ' NOP TRUE ; FALSE ;
        ( cursor keys )
        kcUpArrow ?CaseKeyDef :: GRWCursorTop ;
        kcLeftArrow ?CaseKeyDef :: GRWCursorBegin ;
        kcDownArrow ?CaseKeyDef :: GRWCursorBottom ;
        kcRightArrow ?CaseKeyDef :: GRWCursorEnd ;
        ( RCL key )
        kcSto ?CaseKeyDef :: coord? ITE ERRBEEP GRWRcl ;
        ( DEL key )
        kcBack ?CaseKeyDef :: coord? ITE ERRBEEP GRWDel ;
        ( zoom keys )
        kcTimes ?CaseKeyDef :: GRWRedraw ;
        ( CANCEL and ENTER )
        kcEnter ?CaseKeyDef :: GRWLSEnter ;
        kcRightShift #=casedrpfls
        kcLeftShift #=casedrpfls
        kcNxt #=casedrop :: coord? ITE :: ' NOP TRUE ; FALSE ;
        DROP 'DoBadKeyT
        ;
      2DROP 'DoBadKeyT
    ;

    TrueTrue                              ( key control flags )

    ( softkeys )
    { "NODE"    :: "NODE:" ' GRWNode GRWSetMode ; }
    { "EDGE"  { :: GRWFindNode ITE TRUE ::
                     GRWCreateNode NOTcase FALSE
                     GRWDrawCursor DUPLENCOMP UNCOERCE TRUE
                   ;
                   NOT ?SEMI
                   !mark DUP mark GRGetNode GRNodePoint GRWDrawMark
                   FALSE !path?
                   "EDGE:" { GRWEdge GRWOutEdge GRWInEdge } GRWSetMode
                 ;
                 NOP
                 :: GRWFindNode ITE TRUE ::
                    GRWCreateNode NOTcase FALSE
                    GRWDrawCursor DUPLENCOMP UNCOERCE TRUE
                   ;
                   NOT ?SEMI
                   !mark DUP mark GRGetNode GRNodePoint GRWDrawMark
                   TRUE !path?
                   "PATH:" { GRWEdge GRWOutEdge GRWInEdge } GRWSetMode
                 ; } }
    "CAT" MakeDirLabel ' :: GRWBrowser ; 2 {}N
    { "(X,Y)"   :: "CURS:" ' GRWCursor GRWSetMode ; }
    { "MOVE"    :: GRWFindNode ITE ::
                     !mark DUP mark GRGetNode GRNodePoint GRWDrawMark
                     "MOVE:" ' GRWMove GRWSetMode
                   ;
                   ERRBEEP ; }
    { "DEL"     :: GRWDel ; }
    { "CLEAR"   :: GRWClear ; }
    "SETUP" MakeDirLabel ' :: GRWSetup ; 2 {}N
    { "GROB\8D" :: GRWDrawCursor HARDBUFF TOTEMPOB SWAP GRWDrawCursor ; }
    { "NODE\8D" :: GRWFindNode ITE SWAP ERRBEEP ; }
    { "MARK\8D" :: GRWStoSelect ; }
    { "\8DMARK" :: GRWRclSelect ; }
    { "HELP"    :: GRWHelp ; }
    THIRTEEN {}N

    ONEFALSE                              ( first row, no suspends )
    ' exit?                               ( exit condition )
    ' ERRJMP                              ( error handler )

    POLSetUI
    POLKeyUI

    90 fntfl ITE SetSysFlag ClrSysFlag
    ABND                                  ( abandon local environment )
  ;

  ERRTRAP POLResUI&Err

  GRWFiniDisp                           ( clear display )
  POLRestoreUI                          ( finish POL )
;

* editor entry points ********************************************************

ASSEMBLE
        CON(1)        8                * Tell parser 'Non algebraic'
RPL
xNAME GRW ( -> graph | )
::
  CK0
  NULL{} GRWEditor DROP
;

ASSEMBLE
        CON(1)        8                * Tell parser 'Non algebraic'
RPL
xNAME GRED ( graph -> graph' )
::
  CK1
  DUPTYPELIST? NOTcase :: # 202 ERROROUT ;
  DUP GRParseGraph NOTcase :: # 203 ERROROUT ;
  DUP 1LAMBIND GRWEditor ?SKIP 1GETLAM ABND
;

NULLNAME CONFIG
::
  # 22D TOSRRP
;

